//****** SEEKAPI.H ************** Belenkov O.V.   ****** 08/12/08 ***
//******* SEEKAPI.H ************** Nefedieva O.A.  ****** 07/05/08 ***
//******* SEEKAPI.H ************** Gustinovich N.A.****** 02/10/02 ***
//******* SEEKAPI.H ************** Tarakanova I.R. ****** 24/09/08 ***
//******* SEEKAPI.H ************** Kruzhkov A.E.   ****** 10/11/06 ***
//******* SEEKAPI.H ************** Vitsko D.A.     ****** 22/11/05 ***
//******* SEEKAPI.H ************** Shishkova L.A.  ****** 09/04/08 ***
//*                                                                  *
//*              Copyright (c) PANORAMA Group 1991-2008              *
//*                      All Rights Reserved                         *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*               '                *
//*             C; PASCAL; BASIC         *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*       Windows :                            *
//*                                                                  *
//*    //                                          *
//*    HINSTANCE libInst = ::LoadLibrary("gisacces.dll"); *
//*                                                                  *
//*    //                                                *
//*    HMAP (WINAPI * lpfn_OpenMap)(const char*; long int); *
//*    (FARPROC)lpfn_OpenMap = GetProcAddress(libInst; "OpenMap"); *
//*    HMAP hMap = (*lpfn_OpenMap)("Noginsk.map";0); *
//*                                                                  *
//*    //                                          *
//*    ::FreeLibrary(libInst);       *
//*                                                                  *
//*******************************************************************/
  //*********************************************************
  //*                                                        *
  //*          '         *
  //*                                                        *
  //*           :     *
  //*        (Picture)  -  ; *
  //*       ;  (Map) -  ; *
  //*                                        *
  //*        (Plane)      -  ; *
  //*                                        *
  //*        (Geo)        -  .             *
  //*                                                        *
  //*********************************************************/

 // ;    
 //   ;;   ;
 // ;  c ;    .
 //   WO_INMAP -   
 //  HSELECT !
 //     WO_FIRST  WO_LAST ( 
 //     );  
 //  WO_NEXT  WO_BACK (;  ).
 // enum SEEKTYPE { WO_FIRST  = 0; WO_LAST  = 2;
 //                 WO_NEXT   = 4; WO_BACK  = 8;
 //                 WO_CANCEL = 16; WO_INMAP = 32 };


  
 //     ;   
 //           
 // hMap -   .
 // Obj -    ;
 //           mapCreateObject()
 //         mapCreateSiteObject();
 //             .
 //     ;    !
 // frame -       ;
 //           place (PP_PLANE;PP_GEO; ...)
 //                     // 30/10/06
 //  512512     
 // flag -    (WO_FIRST; WO_NEXT...)
 //    ""    ; 
 //  ;     (  
 //  ).
 //     WO_NEXT;WO_BACK  info 
 //    .
 // place -  .
 //     -  ;
 //  -   info !

function mapWhatObject(Map : HMap;Obj : HObj;Var Frame : TMapDFrame;
       const flag : integer = cWO_LAST; const place: integer = integer(PP_MAP)) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //     ;   ;
 //   
 //           
 //     ;    !
 //   - ;      ()
 //      mapSetSiteActiveSelect()
 // hMap  -   ;
 // Obj -     ;
 //            mapCreateObject()
 //          mapCreateSiteObject();
 //              .
 // frame -       ;
 //           place (PP_PLANE;PP_GEO; ...)
 // flag  -    (WO_FIRST; WO_NEXT...)
 // place -  .
 //     -  

function mapWhatActiveObject(Map : HMap;Obj : HObj;Var Frame : TMapDFrame;
    const flag : integer = cWO_LAST; const place: integer = integer(PP_MAP)) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //    
 // hMap  -   .
 // place -   ;
 //   ;       (WO_LAST;
 // WO_PREV)    ;
 //    ;     (WO_FIRST; WO_NEXT)
 //   
 // -      ( WO_LAST);
 // .. place = 1

procedure mapSetTextPlace(Map : HMap; place: integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapGetTextPlace(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //  '   
 // hMap -   .
 // Obj -    ;
 //           mapCreateObject()
 //         mapCreateSiteObject();
 //             .
 //     ;
 //   HSELECT !
 // select-    ;
 // place -  ;
 // frame -       ;
 //           place (PP_PLANE;PP_GEO; ...)
 // flag  -    (WO_FIRST; WO_NEXT...)
 //    ""    ; 
 //  ;     (  
 //  ).
 //     WO_NEXT;WO_BACK  info 
 //    .
 //     -  ;
 //  -   info !

function mapWhatObjectBySelect(Map : HMap;Obj : HObj; var Frame : TMapDFrame;
   Select : HSelect; const flag : integer = cWO_LAST;
   const place: integer = integer(PP_MAP)) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //      ()   
 //   
 // hMap -   .
 // Obj -   ;
 //             .
 // listname -  () ;
 // key      -    ;
 //    

function mapSeekObject(Map : HMap;Obj : HObj; listname : PChar; 
  key : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapSeekObjectInList(Map : HMap; Site : HSite; Obj : HObj;
    list: integer; key : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //       ()   
 //    (       
 //    ;     )
 // hMap     -   ;
 // listname -  () ;
 // key      -    .
 //    

function mapSeekObjectNumber(Map : HMap; listname: PChar; key : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //        
 // hMap     -   ;
 // info     -   ;
 //                 .
 // select   -   
 // flag     -    (WO_FIRST; WO_NEXT...)
 //     WO_NEXT;WO_BACK  info 
 //    .
 //     -  

function mapSeekSelectObject(Map : HMap;Obj : HObj;Select : HSelect;
   const flag  : integer = cWO_FIRST) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     ;   
 //     ;      !
 // select -   
 //    

function mapSeekSelectObjectCount(Map : HMap; Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //        
 // (     )
 // hMap     -   ;
 // info     -   ;
 //                 .
 // select   -   
 // flag     -    (WO_FIRST; WO_NEXT...)
 //     -  

function mapSeekViewObject(Map : HMap;Obj : HObj;Select : HSelect;
   const flag  : integer = cWO_FIRST): HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   ';    '   .
 //     ;    
 //      -  .
 //  hMap     -   ;
 //  Obj      -   ;
 //                  
 //  target   -     TObjectInfo;
 //                  .
 //      WO_NEXT;WO_BACK  target 
 //      .
 //  select   -   
 //  delta    -      (  0)
 //               MAPADJACENTSECTION  number
 //                   0.
 //  flag     -    (WO_FIRST; WO_NEXT...)
 //      WO_NEXT;WO_BACK  info 
 //     .
 //      -  ;
 //   -       MAPADJACENTSECTION
 //  (. MAPTYPE.H)
 //  subject = 0      
 // ( 1-   ;      - )

function mapSeekAdjacentObject(Map : HMap;Obj, target : HObj;
  var section: TMAPADJACENTSECTION; Select : HSelect;
  Const delta  : double = 0.0;   const flag  : integer = cWO_FIRST or cWO_INMAP;
  const subject : integer = 0) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   ;    '   .
 //     ;    
 //      -  ;
 //   -  .
 //  hMap  -   ;
 //  Obj -    ;
 //               
 //  MAPADJACENTLISTEX -   
 //  count -    
 //  select -     
 //  delta -     
 //  point -  ;  :
 //  0 -   ; 1 - 
 //  subject - 0      
 // ( 1-   ;      - )

function mapSeekAdjacentListEx(Map : HMap;Obj : HObj; list: PMAPADJACENTLISTEX;
   count : integer; Select : HSelect; const delta: double = 0.0;
   const point: integer = 0; const subject: integer = 0) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //  -      /
 //     
 // hMap     -   ;
 // select   -  /
 //    

function mapTestObject(Obj : HObj;Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //  -      /
 //   
 //     
 // hMap     -   ;
 // select   -  /
 //                         // 04/10/07

function mapTotalTestObject(Map : HMap; Obj : HObj) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //         
 // (     )
 // hMap     -   ;
 // hSite    -    ;
 // info     -   ;
 //                 ;
 // list     -   (    1);
 // ObjNumb  -     
 // (  1  mapGetObjectCount(...)  mapGetSiteObjectCount(...)).
 //     "" -  1 !!!
 //      info.
 //    

function mapReadObjectByNumber(Map : HMap;Site : HSite ;
  Obj : HObj; list, ObjNumb  : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //         
 //     "" -  1 !!!
 //      info.
 // hMap     -   ;
 // hSite    -    ;
 // info     -   ;
 //                 ;
 // list     -   (    1);
 // key      -   .
 //    

function mapReadObjectByKey(Map : HMap; Site : HSite ; Obj : HObj;
   list,key : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //*********************************************************
  //*                                                        *
  //*    '    *
  //*                                                        *
  //*********************************************************/

 //      
 // hMap -   ;
 //   = -1;      
 // (0 -  ; 1...n -  )
 //     (-2)

function mapGetTotalSeekMapRule(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //         ;
 //    
 // hMap   -   ;
 // number -  
 // (0 -  ; 1...n -  )
 //       -   

function mapIsTotalSeekMapRule(Map : HMap; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //      
 // hMap     -   ;
 // number   -  ;    ;
 //  number == -1;      
 // (0 -  ; 1...n -  )

procedure mapSetTotalSeekMapRule(Map : HMap;number : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //   
 // hMap -   ;
 //  view == 0;     
 // ;  -   (SeekViewObject())

procedure mapSetTotalSeekViewRule(Map : HMap;const view : integer = 0);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
function mapGetTotalSeekViewRule(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //   /    
 //     
 // hMap     -   ;
 // listname -    (  )
 // key      -     (BaseKey)
 //         ;
 //    (;...) .
 //     -  

function mapSetTotalSeekSample(Map : HMap; listname : PChar; key : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   /    
 // (   )
 // hMap     -   ;
 // acceess  -    :
 // =  0 -       (  );
 // != 0 -       mapTotalSeekObject().
 // (      ;
 //    mapSetTotalSeekSample    )
 //    

function mapSetTotalSeekAccess(Map : HMap; access : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //    ;  
 //  
 // hMap     -   ;
 // hDC      -   ;
 // rect     -    (Draw)   (Picture)
 // color    - ;      
 //    
 //              ::SetViewportOrgEx(hDC; dx ; dy; 0);
 //  dx;dy -     
 //  !
 //    

function mapTotalPaintSelect95(Map : HMap;DC : HDC; var Rect : TRect; 
  Color : TColorRef) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //    ;  
 //  
 // hMap   -   ;
 // hwnd   -   ;
 // color  - ;      ;
 // point -       
 //    place  .
 //    

function mapTotalViewSelect(Map : HMap; Wnd : HWND;
var point: TDoublePoint; Color : TColorRef; place : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //  
 // hMap     -   ;
 //    

function mapTotalSeekObjectCount(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 //     
 // (  mapGetSiteViewSelect();mapGetSiteSeekSelect()...)
 // hMap -   ;
 // Obj -     TObjectInfo
 // flag -    (WO_FIRST; WO_NEXT...)
 //     WO_NEXT;WO_BACK  info 
 //     .
 //     -  

function mapTotalSeekObject(Map : HMap;Obj : HObj; flag : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 //  
 // hMap -   ;
 // flag = 0 -     ;
 //  -       
 //       
 //      

procedure mapSetTotalSelectFlag(Map : HMap; flag : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 //  
 // hMap -   ;
 //   = 0;    

function mapGetTotalSelectFlag(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //    ;  
 // 
 //    
 // hMap   -   ;
 // border -     .
 //    

function mapGetTotalSeekBorder(Map : HMap;var border: TDFRAME) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //*********************************************************
 //*                                                        *
 //*  /  / *
 //*                                                        *
 //*********************************************************/

  //   ( ) /
  //  
  //       : ; ;
  // ;   ; 
  // () ;   () 
  //         
  //   10  ;
  //         -  300 
  //      ; 
  //    
  // hMap   -   ;
  //  hmap ;    /
  //   
  //    

function mapCreateMapSelectContext(Map : HMap) : HSelect ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    ( ) /
  //  
  // select -   ( ) /.
  //      ; 
  //    
  //    

function mapCreateCopySelectContext(Select : HSelect) : HSelect;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ( ) /
  //    /
  // target -   ;   ;
  // source -   .
  // (     ; 
  //    )
  //    

function mapCopySelectContext(target,source: HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  //  /
  // select -  ( ) /.
  //    

function mapClearSelectContext(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //                      // 01/08/08
  //  /   
  // hMap   -   ;
  // hSite    -    ;
  //    

function mapClearSelectContextEx(Select : HSelect; Map : HMap; Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ( ) /
  //  
  // select -  ( ) /.

procedure mapDeleteSelectContext(Select : HSelect);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  // /    
  // select -  ( ) /.
  // flag   -  
  //   

function mapSetInversionSelect(Select : HSelect; flag : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
function mapGetInversionSelect(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 // hselect -  /
 //          -
 //  ;  -  

function mapIsSelectActive(Select : HSelect): integer; // 09/04/08
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  //  ()
  // select -   
  // layer  -  ();   0 (!);
  //   -1 (0xFFFFFFFF);  
  //     ;
  // check  -   (0 -  ; != 0 - )
  //  Layer    Segment

procedure mapSelectLayer(Select : HSelect; layer, check : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //       
  //  ()
  // select -   
  // layer  -  ()
  //   -1 (0xFFFFFFFF);  
  //      (0 - - );
  //  Layer    Segment
  //   : 0 -  ; != 0 - .

function mapCheckLayer(Select : HSelect; layer : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // select -   
  // list   -   ;   1;
  //   -1 (0xFFFFFFFF);  
  //     ;
  // check  -   (0 -  ; != 0 - )

procedure mapSelectList(Select : HSelect; list, check : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // select -   
  // list   -  
  //   -1 (0xFFFFFFFF);  
  //      (0 - - );
  //   : 0 -  ; != 0 - .

function mapCheckList(Select : HSelect; list : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     c  
  // ( )
  // select -   
  // ObjIdx -   ;   1;
  //   -1 (0xFFFFFFFF);  
  //     ;
  // check  -   (0 -  ; != 0 - )

procedure mapSelectObject(Select : HSelect; ObjIdx, check: integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // ( )
  // select -   
  // ObjIdx -  
  //   -1 (0xFFFFFFFF);  
  //      (0 - - );
  //   : 0 -  ; != 0 - .

function mapCheckObject(Select : HSelect; ObjIdx : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     c  
  // (0 - ;1 - ;2-;3-;
  //  4 -  (  2- );
  //  5 -  ( ) )
  // select -   
  // local  -  ;   0;
  //   -1 (0xFFFFFFFF);  
  //     ;
  // check  -   (0 -  ; != 0 - )

procedure mapSelectLocal(Select : HSelect; local, check : integer) ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // select -   
  // local  -  ;   0 (;...);
  //   -1 (0xFFFFFFFF);  
  //      (0 - - );
  //   : 0 -  ; != 0 - .

function mapCheckLocal(Select : HSelect; local : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // select  -   
  // min;max -   ;   0;
  //     -1 (0xFFFFFFFF);  
  //     ;

procedure mapSelectKey(Select : HSelect; nMin, nMax :Cardinal);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // select -   
  // key    -  ;
  //   -1 (0xFFFFFFFF);  
  //      (0 - - );
  //   : 0 -  ; != 0 - .

function mapCheckKey(Select : HSelect; key:Cardinal) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   
  //   0;     

function mapGetMinKey(Select : HSelect) : Cardinal ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   

function mapGetMaxKey(Select : HSelect) : Cardinal;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  // select -   
  // code   -   (1-LESS;3-MORE; ... - . MAPTYPE.H)
  // value  -   
  //    ;  -  

function mapSelectSemanticAppend(Select : HSelect; code,  
 semcode : integer; value : PChar) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //      
  // select -   

procedure mapSelectSemanticClear(Select : HSelect);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   

function mapSelectSemanticCount(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // select -   
  // number -   
  //    

function mapSelectSemanticCondition(Select : HSelect; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //      
  //  : 4 - .; 9 - ; ...
  // select -   
  // number -   
  //    

function mapSelectSemanticCode(Select : HSelect; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  // select -   
  // number -     ( 1  mapSelectSemanticCount())
  //    

function mapSelectSemanticDelete(Select : HSelect; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  // /     
  // select -   
  // code -   :
  // 16 - CMOR :    ;
  // 32 - CMAND :  ; . MAPTYPE.H

procedure mapSelectSemanticLink(Select : HSelect; code : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapGetSelectSemanticLink(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   
  // number -   
  // place  -  ;    
  // size   -   
  //    

function mapSelectSemanticValue(Select : HSelect; number : integer;
     place: PChar; size : integer) : PChar;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // select -   
  // (; ; ; )

function mapSelectMeasureCount(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   

procedure mapSelectMeasureClear(Select : HSelect);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  // select -   
  // measurecode -    : ; ; ;  (. MAPTYPE.H)
  // condition -   (1-CMLESS;3-CMMORE; ... - . MAPTYPE.H)
  // value -    ;   -  . .
  //    condition1  value1;  condition2 = 0;
  //    .
  //    ;   condition2  value2.
  //    condition1   CMMOREEQ (>=);
  // condition2 - CMLESSEQ (<=) !
  //    ;  -    

function mapSelectMeasureAppend(Select : HSelect;  measurecode,
  condition1 : integer; value1: double;
  condition2 : integer; value2: double): integer ; 
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces
  //       
  //     .
  // select -   
  // number -  
  //  1 -   ;
  //            2 -   ;
  //            0 -  .

function mapIsSelectMeasureRange(Select : HSelect; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  // /     
  // select   -   
  // linkcode -   :
  // 16 - CMOR :    ;
  // 32 - CMAND :   (. MAPTYPE.H)

procedure mapSelectMeasureLink(Select : HSelect; linkcode : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
function mapGetSelectMeasureLink(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   
  // number -  
  //  : ;   .. (. MAPTYPE.H)
  //    

function mapSelectMeasureCode(Select : HSelect; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // select -   
  // number -  
  // pvalue1;pvalue2 -    .
  // pvalue2 ;    
  //  1 -   ;
  //            2 -   ;
  //            0 -  .

function mapSelectMeasureValue(Select : HSelect; number : integer;
  var pvalue1,pvalue2 : double) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // select -   
  // number -  
  // pcondition1;pcondition2 -    .
  //  1 -   ;
  //            2 -   ;
  //            0 -  .

function mapSelectMeasureCondition(Select : HSelect; number : integer;
   var pcondition1, pcondition2 : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ;     
  // select -   
  //    

function mapGetSelectRecordSize(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // select -   
  // buffer -  
  // length -  ;  
  //    

function mapGetSelectRecord(Select : HSelect; buffer : Pointer; 
  length : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     
  // select -   
  // buffer -  
  // length -    ;  (  )
  //    

function mapPutSelectRecord(Select : HSelect; buffer : Pointer; 
  length : integer): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        /
  //        
  //  
  // select -   
  //     ; 

function mapIsSample(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //         
  // select -   
  // list   -  
  //     ; 

function mapGetSampleCount(Select : HSelect; list : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //          
  //   
  // select -   
  // list   -    
  // number -        
  //     ; 

function mapGetSampleByNumber(Select : HSelect; list, number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       /
  //        
  //  
  // select -   
  //    ;  
  //    

procedure mapClearSample(Select : HSelect);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  //   ; ;   .
  // select -   
  // complex -    (0/1)
  //   

function mapSetSampleComplex(Select : HSelect; complex : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //         // 02/09/04
  // select -   
  //    

function mapInvertSample(Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      ;  
  //  
  // select -   
  // list   -  ;    
  //    (hMap; hSite)    
  //      
  //   ;     
  //    

function mapSetSampleAllObjects(Select : HSelect; list : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  //     .
  // hMap     -   ;
  // listname -   ;
  // key -     .
  //    .

function mapSelectViewSample(Map : HMap; listname : PChar; key : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //          
  //   .
  // hMap  -   ;
  // hSite -    ;
  //    .

function mapCheckViewSample(Map : HMap; Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //        
  //     .
  // hMap     -   ;
  // listname -   ;
  // key -     .
  //    .

function mapSelectSeekSample(Map : HMap; listname : PChar; key : integer) :integer ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        .
  // select   -   
  // listname -   ;
  // key -     .
  //    .

function mapSelectSample(Select : HSelect; listname : PChar; key : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        .
  // select -   
  // list   -   ;
  // key    -     .
  //    .

function mapSelectSampleByList(Select : HSelect; list, key : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        .
  // select -   
  // list   -   ;
  // number -    .
  //        .
  //    .

function mapSelectSampleByNumber(Select : HSelect; list, number: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // select   -   
  // listname -   
  // key      -     
  //        .
  //    .

function mapUnselectSample(Select : HSelect; listname: PChar; key: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        .
  // select -   
  // list   -   ;
  // key    -     
  //        .
  //    .

function mapUnselectSampleByList(Select : HSelect; list, key: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        .
  // select -   
  // list   -   ;
  // number -    .
  //        .
  //    .

function mapUnselectSampleByNumber(Select : HSelect; list, number: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      .
  // hMap     -   ;
  // Obj    - - 
  // distance -    
  // ;   :
  // filter  - / (1/0)  
  //           (     
  //             )
  // inside  -      :
  //           1 -  ; 2 -   ;
  //           0 -  .
  // visible -  / (1/0)    
  // listname -   . listname = 0; 
  //               .
  // action   -    :
  //            0 -      ;
  //            1 -     (
  //               WM_PROGRESSBAR - maptype.h);
  //                ;
  //    

function mapSelectArea(Map : HMap; Obj : HOBJ; const distance:double = 0.0;
 const filter : integer = 0; const inside : integer = 1;
 const visible : integer = 0; const listname : PChar = nil;
 const action : integer=0) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      .
  // hMap     -   ;
  // object   - - 
  // distance -    
  // nmap     -   ;   
  //             . nmap=-1;   
  // ;   :
  // filter  - / (1/0)  
  //           (     
  //             )
  // inside  -      :
  //           1 -  ; 2 -   ;
  //           0 -  .
  // visible -  / (1/0)    
  // action   -    :
  //            0 -      ;
  //            1 -     (
  //               WM_PROGRESSBAR - maptype.h);
  //                ;
  //    

function mapSelectAreaEx(Map : HMap; Obj : HOBJ; distance: double; 
    filter, inside, visible, action, nmap : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // hMap     -   
procedure mapUnselectArea(Map : HMap) ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //        .
  // hselect -   '
  // object - - 
  // distance -    
  // ;   :
  // filter  - / (1/0)  
  //           (     
  //             )
  // inside  -      :
  //           1 -  ; 2 -   ;
  //           0 -  .
  // visible -  / (1/0)    
  // action   -    :
  //            0 -      ;
  //            1 -     (
  //               WM_PROGRESSBAR - maptype.h);
  //                ;
  //    

function mapSelectSeekArea(Select : HSelect; Obj : HOBJ;
  const distance : double = 0.0; const filter : integer = 0;
  const inside : integer = 1;  const visible : integer = 0; 
const action : integer = 0) : integer;

{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //         .
  // hselect -   '
  // frame  -     
  // distance -    
  // ;   :
  // filter  - / (1/0)  
  //           (         )
  // inside  -      :
  //           1 -  ; 2 -   ;
  //           0 -  .
  // visible -  / (1/0)    
  // action   -    :
  //            0 -      ;
  //            1 -     (
  //               WM_PROGRESSBAR - maptype.h);
  //                ;
  //    

function mapSelectSeekAreaFrame(Select : HSelect; var frame : TMapDFrame;
  const distance : double = 0.0; const filter : integer = 0;
  const inside : integer = 1;  const visible : integer = 0; 
  const action : integer = 0) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //        
  // hselect -   

procedure mapUnselectSeekArea(Select : HSelect);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //       
  // hselect -  /
  //   = 0 -  
  //                  1 -  

function mapGetAreaSelectFlag(Select : HSelect): integer; //07/04/08
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces
 //         
 // hselect -  /
 //   = 0 -   "" ;
 //                  1 -    ;
 //                  2 -    .

function mapGetDrawObjectsFlag(Select : HSelect): integer; //07/04/08
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces


 //         
 // hselect -  /
 // flag = 0 -   "" ;
 //        1 -    ;
 //        2 -    .

procedure mapSetDrawObjectsFlag(Select : HSelect; flag: integer); //07/04/08
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces

  //       
  //    
  // hMap     -   ;
  // (        
  //  )

function mapFreezeMapContents(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //         
  // hMap     -   ;
  //    

function mapDefreezeMapContents(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //*********************************************************
 //*                                                        *
 //*                          *
 //*                                                        *
 //*********************************************************/

  //    ;   
  // info    -    
  // point   -    
  //             ;    
  // subject -   
  //           (0 - ; 1 -    ..;
  //             -1  -    )
  //         
  //  mapGetCurrentSubject()
  //    (    1)
  //    0

function mapSeekNearPoint(Obj : HObj; var point: TDoublePoint;
         subject : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       ;
  //   
  // hMap    -   ;
  // info    -    
  // pointin -    
  //             ;    
  //       
  //       
  //   ( )    pointout

function mapSeekNearVirtualPoint(Map : HMap; Obj : HObj;
   var pointing, pointout: TDoublePoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     ;
  //   
  //   pointin   
  //   ;    
  // hMap    -   ;
  // info    -    
  // subject -   
  // ( 0 - ; 1 -    ..)
  //       
  //       
  //   ( )    pointout

function mapSeekNearVirtualPointSubject(Map : HMap; obj: HObj;
  subject: integer;  var pointing, pointout: TDoublePoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     ( )
  // hObj -    
  //    ;   
  //    -   

function mapGetCurrentSubject(Obj : HObj) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ;   
  //  ( )   
  // info   -    
  // number -   
  // distance - 
  //  distance > = 0 -    
  //               <   0 -    
  // point -   
  //         (      )
  // subject -  
  //   ;    
  // c  
  //    -    
  //    0

function mapSeekVirtualPointByDistance(Obj : HObj; number : integer;
 distance : double; var point: TDoublePoint; subject : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  
  //   ;   
  //  ( )      
  // hmap    -   ;
  // number -   
  // distance - 
  //  distance > = 0 -    
  //               <   0 -    
  // point -   
  //         (      )
  // subject -  
  //   ;     c  
  //    -    
  //   ( ; ...)     
  //    0

function mapSeekVirtualPointByDistanceWithHeight(Map : HMap; Obj : HObj;
   number : integer; distance :double; var point: TDoublePoint; 
   subject : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //********************************************************************
 //*       '                 *
 //*                                                                  *
 //*   ; ..    ; *
 //*    (  ) - (  ) *
 //*  (  ) - ;  .            *
 //*       !!!                   *
 //********************************************************************

 // *********************************************************
 //
 //  :
 // =============
 // Cross : HCross = mapCreateObjectsCross(info1;info2;method;precision)
 // if (hCross)
 //    {
 //    while(mapGetNextCross(hCross;info))
 //         {
 //         ...
 //         }
 //    mapFreeObjectsCross(hCross);
 //    }
 //**********************************************************

 //   ; ..    ;
 //    (  ) - (  )
 //  (  ) - ;  .
 //
 //   
 //       !!!
 // info1 -    -  (  ;   )
 // info2 -    (   )
 // 
 // info1 -    -  (    )
 // info2 -    (   )      // 09/08/04
 //       - mapCreateObjectsCrossSquare(...)
 // method -   
 //          LOCAL_SQUARE - ; LOCAL_LINE - 
 //               
 //           :
 //          -    ;    LOCAL_LINE;
 //          -    ;     LOCAL_LINE  LOCAL_SQUARE.
 //    method     (FLAGINSIDEOBJECTS = 32
 // . maptype.h)      ;   
 //   -   (. LOCAL_SQUARE | FLAGINSIDEOBJECTS)     //24/08/04
 // precision -    ( );  precision=0      //24/05/07
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //     
 //        0


function mapCreateObjectsCross(Obj1,Obj2 : HObj; method : integer; precision: double) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //   
 //   

procedure mapFreeObjectsCross(Cross : HCross);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //   
 //  
 // Obj - 
 //    0

function mapGetNextCross(Cross : HCross; Obj : HObj) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //     
 //       !!!
 // info1 -   
 // info2 -   
 //   ;  1
 //        0

function mapGetObjectsCross(Obj1, Obj2 : HObj) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 // ()  
 //       !!!
 //        !!!
 // info1 -   
 // info2 -   
 // Obj -  
 // method -   
 //          LOCAL_SQUARE - 
 //          (        );
 //          LOCAL_LINE - 
 //          (       ;
 //              )
 // precision -    ( );  precision=0  
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //      (info)
 //    0

function mapGetObjectsUnion(Obj1, Obj2, Obj : HObj; method : integer; precision: double) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

//  ()    ( "")
//    ( "") !!!
// info1     -   
// info2     -   
// info      - 
// precision -    ( );
//                   
//               (  ;  - )
// always    -   
//             1 -  
//             0 -      precision      // 10/11/06
//                     
//      (info)
//    0

function mapSquareObjectsUnion(Obj1, Obj2, Obj : HObj; precision: double;
  always : integer): HObj; // 03/11/06
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


 //*************************************************************
 //*       '          *
 //*                                                            *
 //*   ; ..     *
 //*  ;         *
 //*      .                           *
 //*       !!!             * 
 //**************************************************************/

 // *********************************************************
 //  :
 // =============
 // Cross : HCross = mapCreateObjectsConsent(info1;info2;method;precision)
 // if (hCross)
 //    {
 //    while(mapGetNextConsent(hCross;info))
 //         {
 //         ...
 //         }
 //    mapFreeObjectsConsent(hCross);
 //    }
 // **********************************************************

 //   ; ..   
 //  ;      
 //      .

 //   
 //       !!!
 // info1 -   ;   
 //            
 //         (     )
 // info2 -   ;     
 //         ;        
 //            (  
 //             )
 // method -   
 //          LOCAL_SQUARE - ; LOCAL_LINE - 
 //               
 //           :
 //          -    ;    LOCAL_LINE;
 //          -    ;     LOCAL_LINE  LOCAL_SQUARE.
 // precision -    ( );  precision=0  
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //     
 //    0


function mapCreateObjectsConsent(Obj1, Obj2 : HObj; method: integer;
  precision : double) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   
 //   
 // hCross -    

procedure mapFreeObjectsConsent(Cross : HCross);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   
 //  
 // hCross -    
 // info   - 
 //    0

function mapGetNextConsent(Cross : HCross; Obj : HObj) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;



 //*****************************************************************
 //*      '   *
 //*                    ' !!!            *
 //*****************************************************************

 // **********************************************************
 //  :
 // =============
 // Cross : HCross = mapCreateObjectCrossPoints(info1;info2)
 // CROSSPOINT point;
 // if (hCross)
 //    {
 //    int count = mapGetCrossCount(hCross);
 //    for(int i = 1; i <= count; i++)
 //         {
 //         mapGetCrossPoint(hCross;i;(HPOINT)&point);
 //         ...
 //         }
 //    mapFreeCrossPoints(hCross);
 //    }
 // **********************************************************

 //     
 //    
 // info1 -    ( ; )
 // info2 -    ( ; )
 // precision -    ( );  precision=0  
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //     
 //    0

function mapCreateObjectCrossPointsEx(Obj1,Obj2 : HObj; precision : double) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //       !!!
 //    
 // info1 -   
 // info2 -    
 //     
 //    0

function mapCreateObjectCrossPoints(Obj1,Obj2 : HObj) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //    
 // hCross -    
 //    0

function mapGetCrossCount(Cross : HCross) : integer  ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //  
 // hCross -    
 // number -   ( 1)
 // point  -  (    )
 //    0

function  mapGetCrossPoint(Cross : HCross;number : integer; point : PCrossPoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //  
 // hCross -    

procedure mapFreeCrossPoints(Cross : HCross);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;



 ///**********************************************************
 //*      '/' *
 //*                                         *
 //*                  '   !!!       *
 //**********************************************************/

 // *********************************************************
 //  :
 // =============
 // Cross : HCross = mapCreateSubjectCrossPoints(info1;info2;
 //                                             subject1; subject2)
 // CROSSPOINT point;
 // if (hCross)
 //    {
 //    int count = mapGetCrossCount(hCross);
 //    for(int i = 1; i <= count; i++)
 //         {
 //         mapGetCrossPoint(hCross;i;(HPOINT)&point);
 //         ...
 //         }
 //    mapFreeCrossPoints(hCross);
 //    }
 //**********************************************************

 //     /
 //    
 // info1 -    (  )
 // info2 -    (  )
 // subject1 -   info1
 // subject2 -   info2
 // precision -    ( );  precision=0  
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //     
 //    0

function mapCreateSubjectCrossPointsEx(Obj1, Obj2 : HObj; 
  subject1, subject2: integer; precision : double) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
                                     
 //     /
 //    
 // info1 -    (  )
 // info2 -    (  )
 // subject1 -   info1
 // subject2 -   info2
 //     
 //    0

 function mapCreateSubjectCrossPoints (Obj1, Obj2 : HObj; subject1, subject2: integer) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //       
 //        0
 //  info1 -   
 //  info2 -   
 //  30/03/00

function mapInsertPointCross(Obj1, Obj2 : HObj) : integer  ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //  (   )
 //  info1 -   
 //  info2 -   
 //  : 1 -    ;
 //              2 -    ;
 //              3 -  ;
 //              4 -   
 //     0
 //  20/04/00

function mapCheckInsideObject(Obj1, Obj2 : HObj) : integer  ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      ( )
 //  (   )
 //  info1 -   
 //  info2 -   
 //  : 1 -    
 //                 (  ..  );
 //            - 1 -      
 //                 (  ..  );
 //              2 -    
 //                 (  ..  );
 //            - 2 -      
 //                 (  ..  );
 //              3 -  ;
 //              4 -   
 //     0
 //  09/06/01

function mapCheckInsideObjectEx(Obj1, Obj2 : HObj) : integer  ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
//      ( )
//  (   )
//  : 1 -    
//                 (  ..  );
//            - 1 -      
//                 (  ..  );
//              2 -    
//                 (  ..  );
//            - 2 -      
//                 (  ..  );
//              3 -  ;
//              4 -   
//              5 - ()   
//   point       
//     0
//  24/09/08

function mapCheckInsideObjectPoint(Obj1,Obj2 : HObj; var point : TDoublePoint) : integer  ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //      
 //  (   )
 //  info    -  ;
 //  subject -  (0)  ;
 //  point   -     .
 //  : 1 -   ();
 //              2 -    ();
 //              3 -     ;
 //              4 -    .
 //     0

function mapCheckInsidePoint(Obj : HObj; subject :integer;
     var point: TDoublePoint) : integer  ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 //  Obj -  ;
 //  area -  (    ;
 //                  ..     )
 //  precision -  ( )
 //  : 1 -   
 //                 (    ..  );
 //              2 -   
 //              3 -    ;
 //              4 -     
 //              5 -       
 //              6 -      
 //     0
 //  21/02/01

function mapCheckOverlap(Area, Obj : HObj;const precision : double = 0): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces
 //    
 // xy1;xy2 -  ;
 // xy3;xy4 -  
 // point1;point2  -  
 // precision -  ( )
 //  : 1 -   ;
 //           2 -  xy1;xy2     xy3;xy4
 //        

function mapCrossCutData(xy1, xy2, xy3, xy4  : TDoublePoint; var point1, point2 : TDoublePoint;
    const precision : double  = cDELTANULL) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 // ----------------------------------------------------------
 //      / 
 // xy1; xy2 -  
 // data -  /
 // subject -  /
 // ( 0 - ; 1 -    ..)
 // first -    
 // last  -    
 //    NUMBERPOINT; 
 //   ;  
 //    
 //  DOUBLEPOINT -   
 //      xy1;xy2 
 //   
 //        
 // ----------------------------------------------------------
function mapCrossCutAndSubject(Obj : HObj; var xy1, xy2: TDoublePoint;
      first, last : integer; var point1, point2 :TNumberPoint;
      subject : integer; precision:  double) : integer; // 31/01/06
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //    
 // point     -  
 // xy1;xy2   -   
 // precision - 
 //  POINTPOSITION (PS_FIRST; PS_LEFT... - maptype.h)
 //    0

function mapGetPointPosition(var point, xy1, xy2: TDoublePoint;
        precision : double = cDELTANULL) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //        (point1-point2)
 //   (+/-) distance    point (  point1)
 // pointout1; pointout2 -   
 // point1;point2        -   
 // point                -  ;    
 // distance             -    point
 //    0

function mapSeekPointNormalLine(var point1, point2, pointout1, pointout2 : TDoublePoint;
    distance : double; var point : TDoublePoint): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

   //**********************************************************
  //*                                                         *
  //*       '         *
  //*                                                         *
  //**********************************************************/

 // *********************************************************
 //  :
 // =============
 // Cross : HCross = mapCreateObjectCutByLine(info1;info2;method;precision)
 // if (hCross)
 //   {
 //     while(mapGetNextCut(hCross;info))
 //     {
 //        ...
 //     }
 //     mapFreeObjectsCut(hCross);
 //   }
 //**********************************************************

 //     
 //   
 // info1 -   ;   
 // info2 -  ;   (;c )
 // method -   :
 //          LOCAL_LINE - ;
 //          LOCAL_SQUARE - 
 // precision -    ( );  precision=0  
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //     
 //    0

function mapCreateObjectCutByLine(Obj1, Obj2 : HObj; 
 method : integer; precision : double) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //   
 // hCross -    

procedure mapFreeObjectsCut(Cross : HCross);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //  
 // hCross -    
 // info   - 
 //    0

function mapGetNextCut(Cross : HCross; Obj : HObj) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;



  //*********************************************************************
  //*                                                                    *
  //*        '         *
  //*                                                                    *
  //*    (   ); *
  //* ..                                         *
  //*    (  ) - (  )   *
  //*  (  ) - ;  .              *
  //*     !!!                                  *
  //**********************************************************************/

 // *********************************************************
 //  :
 // =============
 // Cross : HCross = mapCreateObjectsCrossSquare(info1;info2;method;precision)
 // if (hCross)
 //   {
 //    while(mapGetNextCross(hCross;info))
 //    {
 //      ...
 //    }
 //    mapFreeObjectsCross(hCross);
 //   }
 //**********************************************************

 //      (   )
 //     !!!
 // info1 -    -  (    )
 // info2 -    (    )
 // precision -    ( );  precision=0  
 //             0.001    <= 500000;
 //             0.01     500000;  precision  ; 
 //               
 //     
 //    0

function mapCreateObjectsCrossSquare(Obj1,Obj2 : HObj; precision : double) : HCross;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //        13/01/03
 // Obj -  
 // precision -    0 ( )
 //   

function mapSetPrecision(Obj : HObj; precision : double) : double;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;



  //*******************************************************************
  //*                                                                  *
  //*        ;      *
  //*                                                    *
  //*                                                                  *
  //*   :                                                  *
  //*                                                                  *
  //*  32801 -  ;     ; *
  //*  32802 -  ;        *
  //*          ;                *
  //*  32803 -  ;            *
  //*          .                                               *
  //*                                                                  *
  //*         ;  *
  //*         *
  //*     .                          *
  //*                                                                  *
  //********************************************************************/

 // *********************************************************
 //  :
 // =============
 // ObjSet : HObjSet = mapCreateObjectSet()
 // if (hObjSet)
 //   {
 //     ...  
 //     mapFreeObjectSet(hObjSet);
 //   }
 //**********************************************************

 //    ;   
 // 
 //    0

function  mapCreateObjectSet : hObjSet;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //    ;   
 // 
 // hobjset -    

procedure mapFreeObjectSet(ObjSet : HObjSet);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //      
 // hobjset -    
 // info    -   
 //    0

function mapBuildObjectSet(ObjSet : HObjSet; Obj : HObj) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 //        
 // hobjset -    
 // info    -   
 // semtype -       info
 //           GROUPLEADER; GROUPSLAVE; GROUPPARTNER
 //  type = 0 -     
 // (  mapBuildObjectSet );
 //    0

function mapBuildObjectSetByType(ObjSet : HObjSet; Obj : HObj; semtype:integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 // hobjset -    
 // hselect -  
 //    0

function mapBuildSelect(ObjSet : HObjSet; select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 // hobjset -    
 //    0

function mapObjectSetCount(ObjSet : HObjSet) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //       (  1)
 //  HOBJ    !!! 
 // hobjset -    
 // number  -    
 //    0

function mapObjectSetObject(ObjSet : HObjSet; number : integer) :HObj ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //    
 // hobjset -    
 // frame   -  ( )    
 //    0

function mapObjectSetFramePlane(ObjSet : HObjSet; var frame : TMapDFrame) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      (  32801)
 // hobjset -    
 // number -      (    )
 //  number = 0;      
 //    0

function mapObjectSetNominateLeader(ObjSet : HObjSet; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //        ( 1)
 //    
 //      -   
 // hobjset -    
 // number -    
 // save -    
 //  =  0 -  ; 1 - 
 //    0

function mapObjectSetClearObject(ObjSet : HObjSet; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 // hobjset -    
 // save    -    
 //           =  0 -  ; 1 - 

procedure mapObjectSetClear(ObjSet : HObjSet; save : integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     ( )
 // groupnumber - ;    
 // (  )  0
 // hobjset -    
 // hobj    -  
 //     (GROUPLEADER;GROUPSLAVE;GROUPPARTNER)  0

function mapObjectSetIsGroup(ObjSet : HObjSet; Obj : HObj;
   var groupnumber : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //        
 // hobjset -    
 // hobj    -  
 // gsemtype -    
 //        GROUPLEADER; GROUPSLAVE; GROUPPARTNER
 //     0  

function mapObjectSetGetTypeSemn(ObjSet : HObjSet; Obj : HObj; gsemtype:integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 // hobjset -    

function mapObjectSetDelete(ObjSet : HObjSet) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 // group -  
 //  group == 0;      hobjset
 // hobjset -    
 // hobj    -  

function mapObjectSetDeleteSemantic(ObjSet : HObjSet; Obj : HObj;
  group : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //  
 // hobjset -    
 // hmap    -   
 // hDC     -   
 // Rect    -  

function mapPaintObjectSet(ObjSet : HObjSet; Map : HMap;
    DC : HDC; var rect : TRect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
 //  
 // hobjset -    
 // always  -    ;   
 //         = 0 -  
 //         = 1 - 

function mapObjectSetSave(ObjSet : HObjSet; always: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //          ( 1)
 // hobjset -    
 // number  -   
 // save -   
 //      =  0 -  ; 1 - 

function mapObjectSetRemoveNumber(ObjSet : HObjSet; number, save : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     (   32801)
 // hobjset -    
 // save -    : = 0 -  ; 1 - 
 //  hobj -    (Key = 0)  save = 1
 //              info  ;     
 //   hobj      
 // -   ;    
 //   hobj      
 // -    (     )
 //      0

function mapObjectSetAppendGeneral(ObjSet : HObjSet; Obj : HObj; save : integer): integer ; // 02/10/02
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


 //     (   32801)
 // hobjset -    
 // save -    : = 0 -  ; 1 - 
 //  hobj -    (Key = 0)  save = 1
 //              info  ;     
 //   hobj      
 // -      
 //      0

function mapObjectSetAppendGeneralNew(ObjSet : HObjSet; Obj : HObj; save : integer): integer ; // 02/10/02
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


 //     (   32802)
 // hobjset -    
 // save -    : = 0 -  ; 1 - 
 //  hobj -    (Key = 0)  save = 1
 //              info  ;     
 //   hobj      
 // -    (     )
 //   hobj      
 // -   ;   
 //      0

function mapObjectSetAppendSubordinate(ObjSet : HObjSet; Obj : HObj; save : integer): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     (   32802)
 // hobjset -    
 // save -    : = 0 -  ; 1 - 
 //  hobj -    (Key = 0)  save = 1
 //              info  ;     
 //   hobj      
 // -      
 //      0

function mapObjectSetAppendSubordinateNew(ObjSet : HObjSet; Obj : HObj; save:integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //     
 // hobjset -    
 // group -  
 //          group = 0 -      hobjset
 //  HOBJ    !!!

function mapObjectSetFindGeneral(ObjSet : HObjSet; group : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   ObjSet1  ObjSet2
 // regime -
 //    = 1 -    
 //              -  ;   
 //             
 //                -     ;
 //             set
 //    = 2 -   
 //             set       
 //    = 3 -   
 //               set     
 //             ;  
 // Obj -     set 
 //     hobjset
 // save -   
 //      =  0 -  ; 1 - 

function mapObjectSetUnion(ObjSet1, ObjSet2: HObjSet; 
   regime:integer; Obj : HObj; save:integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //*******************************************************************
 //*                                                                  *
 //*                *
 //*                                                  *
 //*                                                                  *
 //********************************************************************/

 //      
 //    .]
 // hMap -    ;
 //     - semanticCode; 
 //       .
 //   (point->X;point->Y)    
 //    .
 //      value.
 //     0
 // 06/10/05

function mapCalcCharacteristic(Map : HMap; var point : TDoublePoint;
    semanticCode : integer; var value: double) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
