//******* MAPGDI.H *************** Kruzhkov A.E.   ****** 15/02/09 ***
//******* MAPGDI.H *************** Belenkov O.V.   ****** 16/02/09 ***
//******* MAPGDI.H *************** Panteleeva N.A. ****** 31/03/08 ***
//******* MAPGDI.H *************** Kruzhkova E.A.  ****** 19/03/08 ***
//*                                                                  *
//*              Copyright (c) PANORAMA Group 1991-2009              *
//*                      All Rights Reserved                         *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*                 *
//*              '                 *
//*                                                                  *
//*******************************************************************/

//{$I gtktype.inc}

//    (  Image  IMG_OBJECT)
const
  IM_PRESS       = $00000000;  //     ( )
  IM_DONTPRESS   = $04000000;  //    
  IM_SCALE       = $01000000;  // 
  IM_DONTSCALE   = $02000000;  //  
  IM_SCALEDONTPRESS  = IM_SCALE or IM_DONTPRESS;  //  
  IM_CLEARSCALE = $0F8FFFFFF;  //   


//-----------------------------------------------------------------
//     '
//-----------------------------------------------------------------
//-----------------------------------------------------------------
//   
//-----------------------------------------------------------------
//        .
//    - 5 : 4  -  = 5  1  = 0
//     '\n',
//      
//-----------------------------------------------------------------


//-----------------------------------------------------------------
//     
//-----------------------------------------------------------------


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++     '  +++++++++
//++++++++++++++       +++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++

const
  PF_TESTTEXT    = 1 ;   //     
  PF_SKIPNUMBER  = 2 ;   //     #          // 20/02/07
  PF_UNICODETEXT = 4 ;   //    UNICODE             // 02/06/07

type

TPOLYDATA  = packed record
  Points        : PPoints;   //     POINT
                             //   
  PolyCounts    : PInteger;  //    
  Count         : integer;   //   (, )
  Text          : PPointer;  //     
                             //  (  
                             //    )
  AlignCode     : integer;   //     
  Semantic      : Pointer;   //     (SEMANTIC *)
                             //       -  0
  Border        : TRect;     //     
                             //   
  ShowScale     : double;    //     
end;

//******************************************************************
//      '  
//******************************************************************
 const
  IMG_DRAWLINE    = 1;        //      IML
  IMG_DRAWSQUARE  = 3;        //      IML

  IMG_EMPTY             = 127;  //   -  
  IMG_LINE              = 128;  // + 
  IMG_DOT               = 129;  // + 
  IMG_SQUARE            = 135;  // + 
  IMG_CIRCLE            = 140;  //   
  IMG_TEXT              = 142;  //   
  IMG_MULTIMARK         = 143;  // +   
  IMG_MULTISQUAREMARK   = 144;  //   ,   
  IMG_DRAW              = 147;  // +   
  IMG_DOTSHIFT          = 148;  //    
  IMG_VECTOREX          = 149;  // +  
  IMG_TEMPLATE          = 150;  //    ( )
  IMG_TRUETYPE          = 151;  // -  TrueType
  IMG_TRUETEXT          = 152;  //   
  IMG_HATCHSQUARE       = 153;  //    
  IMG_SQUAREGLASS       = 154;  // + -
  IMG_SQUAREVECTOR      = 155;  //   ,   
  IMG_VECTOREXTURN      = 156;  //     ()
  IMG_DECORATE          = 157;  //       
  IMG_DASH              = 158;  //    
  IMG_LINESHIFT         = 159;  //    
  IMG_VECTORTEXT        = 160;  // -    
  IMG_VECTORNODE        = 161;  //      (IMGVECTOREX)
  IMG_THICKENLINE       = 162;  //    
  IMG_MIDDLETHICKENLINE = 163;  //        
  IMG_SQUAREGLASSCOLOR  = 164;  // + - 
  IMG_GRAPHICMARK       = 165;  //      (, Metafile )
  IMG_HATCHSQUARESHIFT  = 166;  //        // 31/03/08
  IMG_POLYGONGLASS      = 167;  // + -     // 19/01/09
  IMG_LINEGLASS         = 168;  //   -       // 23/01/09
  IMG_DOTGLASS          = 169;  //    -    // 15/02/09
  IMG_MULTIMARKGLASS    = 170;  //   -    // 14/02/09
  IMG_VECTORGRADIENT    = 199;  //    
  IMG_PERCENT           = 249;  //     IMG_LONG
  IMG_LIBRARY           = 250;  //    IML
  IMG_SEMANTIC          = 251;  // +   IMG_LONG
  IMG_COLOR             = 252;  //     IMG_LONG
  IMG_DOUBLE            = 253;  //     DOUBLE
  IMG_LONG              = 254;  //     LONG
  IMG_OBJECT            = 255;  //        


  IMG_LINEDOT           = 130;
  IMG_DOUBLELINE        = 131;
  IMG_DOTDLINE          = 132;
  IMG_DOUBLEDOT         = 133;
  IMG_SHIFTLINEDOT      = 134;
  IMG_POLY_FILL         = 135;      //   
  IMG_SQUARECROSS       = 136;
  IMG_MARK              = 137;
  IMG_SQUAREMARK        = 138;

 
//   ( IMG_SQUAREMARK, IMG_MULTISQUAREMARK,
//                      IMG_SQUARECROSS, IMG_FONT, IMG_SQUAREGLASSCOLOR)
  IMGC_TRANSPARENT   = $0FFFFFFFF;
//  IMGC_NOMARK        = $0FFFFFFFF;  //   ( IMG_OBJECT)

//      (|IMGC_INDEX, RGB)
  IMGC_INDEX         = $0F0000000;  //     
  IMGC_CLEARINDEX    = $0FF000000;  //     (& IMGC_CLEARINDEX)
  IMGC_CLEARCOLOR    = $000FFFFFF;  //         (& IMGC_CLEARCOLOR)
   {
//    
// color -     RSC,   0 !!!
//   IMGC_INDEX  ,    RGB
#define SETCOLORINDEX(color)   (((long int)(color))|IMGC_INDEX)

#define IMGC_SYSTEM        = $0F1000000L  //      (LINUX)  // 16/10/03
#define SETCOLORSYSTEM(color)  (((long int)(color))|IMGC_SYSTEM)

//    (: 0 - RGB, 1 -   )
#define TESTCOLORINDEX(color)  ((((long int)(color))&IMGC_CLEARINDEX)==IMGC_INDEX)

//    (: 0 - RGB, 1 -    )
#define TESTCOLORSYSTEM(color) ((((long int)(color))&IMGC_CLEARINDEX)==IMGC_SYSTEM)  // 16/10/03
      }
//    4x4 (16 ) ( IMG_SQUAREMARK, IMG_MULTISQUAREMARK)
//  1 -   
//  0 - 
//   :
//  0000(0)  1111(F)  1010(A)  0101(5)
//  0000(0)  1111(F)  0101(5)  1010(A)
//  0000(0)  1111(F)  1010(A)  0101(5)
//  0000(0)  1111(F)  0101(5)  1010(A)
 IMGK_REGULAR0      = $00000000;  //  ( )
 IMGK_REGULAR       = $0000FFFF;  //  ( )
 IMGK_ONECHESS      = $0000A5A5;  // 
 IMGK_TWOCHESS      = $00005A5A;  //  

//   ( IMG_OBJECT)
   IMGL_LINE      = 0;  // 
   IMGL_SQUARE    = 1;  // 
   IMGL_POINT     = 2;  // 
   IMGL_TITLE     = 3;  // 
   IMGL_VECTOR    = 4;  // 
   IMGL_MIXED     = 5;  //   ()

//  p ( IMG_SQUARECROSS)
   SC_HORIZONTAL  = 1;  // p 
   SC_VERTICAL    = 2;  // pa 
   SC_QUADRATIC   = 3;  // a
   SC_CROSS45     = 4;  //   45 
   SC_CROSS135    = 5;  //   135 

//    ( SCR_VECTOR)
   VT_THICK2      =  2;  //   2
   VT_THICK3      =  3;  //   3
   VT_THICK4      =  4;  //   4
   VT_THICK5      =  5;  //   5
   VT_CIRCLE2     =  8;  //   2
   VT_CIRCLE3     =  9;  //   3
   VT_CIRCLE4     = 10;  //   4
   VT_CIRCLE5     = 11;  //   5

//    (IMG_VECTOREX)
   VT_SQUARE      =  0;  // 
   VT_LINE        =  1;  // 
   VT_ROUND       =  6;  //  ()
   VT_CIRCLE      =  7;  // 
   VT_FREE        = 12;  //   

//    (IMG_VECTOREX)
   VT_ELLIPSE    = 64;  // 
   VT_OVAL       = 65;  //  ()
   VT_ARC        = 66;  //   
   VT_PIE        = 67;  //  ()
   VT_TEXT       = 68;  //    ()
   VT_STEXT      = 69;  //    ( )
   VT_ARC_REVERT = 70;  //   

//       
   VT_OBJECT    = 101;  //  
   VT_SUBJECT   = 102;  //  
   VT_END       = 103;  //  

//       
 //  PIX2MKM(pixel)  (((long int)(pixel))  * MKMINPIX)
 //  MKM2PIX(metric) (((long int)(metric)) / MKMINPIX)

//------------------------------------------------------------------
//  IMG_FONT
//------------------------------------------------------------------

//   (  )
   UNIC_TRANSPARENT  = 255;

//   
   UNIW_NORMAL       = 0;  // 
   UNIW_NARROW       = 1;  // 
   UNIW_WIDE         = 2;  // 

//   
   UNIA_BASELINE     = 0;  //   
   UNIA_TOP          = 1;  //  
   UNIA_BOTTOM       = 2;  //  

//   
   UNIA_LEFT         = 0;  //   
   UNIA_CENTER       = 1;  //  
   UNIA_RIGHT        = 2;  //   

//      
   CharMin  = 5; //   < CharMin,  
                    // 5 - 25/10/99

//    (mapgds.h)
//  UNIW_NORMAL     - 
//  UNIW_NARROW     - 
//  UNIW_WIDE       - 

{$ifdef LINUXAPI}  // 23/04/01
//  ,   (Windows-)
//  FW_THIN         - 
//  FW_ULTRALIGTH   - 
//  FW_NORMAL       - 
//  FW_MEDIUM       - 
//  FW_BOLD         - 
   FW_DONTCARE         = 0;
   FW_THIN             = 100;
   FW_EXTRALIGHT       = 200;
   FW_LIGHT            = 300;
   FW_NORMAL           = 400;
   FW_MEDIUM           = 500;
   FW_SEMIBOLD         = 600;
   FW_BOLD             = 700;
   FW_EXTRABOLD        = 800;
   FW_HEAVY            = 900;
   FW_ULTRALIGHT      = FW_EXTRALIGHT ;
   FW_REGULAR         = FW_NORMAL ;
   FW_DEMIBOLD        = FW_SEMIBOLD;
   FW_ULTRABOLD       = FW_EXTRABOLD ;
   FW_BLACK           = FW_HEAVY ;

{$endif} // LINUXAPI


//    (Windows-)
   FA_LEFT      = 0;     //  = TA_LEFT       // 14/09/00
   FA_RIGHT     = 2;     //  = TA_RIGHT     // 14/09/00
   FA_CENTER    = 6;     //   = TA_CENTER // 14/09/00

//    (Windows-)
   FA_TOP       = 0   ;  //  = TA_TOP       // 14/09/00
   FA_BOTTOM    = 8   ;  //  = TA_BOTTOM     // 14/09/00
   FA_BASELINE  = 24  ;  //    = TA_BASELINE  // 14/09/00
   FA_MIDDLE    = 4120;  //    = (TA_BASELINE|0x01000) // 14/09/00

//   
   FA_MASK     = FA_CENTER or FA_MIDDLE;         // 23/04/03


//    (,   )
   CA_BASELINE_LEFT       =    20;
   CA_BASELINE_RIGHT      =    21;
   CA_BASELINE_CENTER     =    22;

   CA_MIDDLE_LEFT         =    23;
   CA_MIDDLE_RIGHT        =    24;
   CA_MIDDLE_CENTER       =    25;

   CA_TOP_LEFT            =    26;
   CA_TOP_RIGHT           =    27;
   CA_TOP_CENTER          =    28;

   CA_BOTTOM_LEFT         =    29;
   CA_BOTTOM_RIGHT        =    30;
   CA_BOTTOM_CENTER       =    31;

//    
   CA_MINCODE  = CA_BASELINE_LEFT;
   CA_MAXCODE  = CA_BOTTOM_CENTER ;

//   (Windows-)
//  RUSSIAN_CHARSET -   (ANSI/WINDOWS)
//  OEM_CHARSET     -   (OEM/866/DOS)
//------------------------------------------------------------------

//******************************************************************
//                                  *
//******************************************************************
//        (, ,  ...)      *
//                 (   )                   *
//******************************************************************
// :                                                     *
//  1.    COLORREF (0x00BBGGRR)         *
//         ,      = $0F *
//  2.       ()            *
//       PIX2MKM( ):              *
//     Parm->Thick = PIX2MKM(2);  ( 2 )              *
//******************************************************************
type
 // +  TRscObjLine
 PIMGLINE = ^TIMGLINE;
 TIMGLINE = packed record               // (128) 
   Color : TColor;                      //   (COLORREF)
   Thick : integer;                     //  
 end;

 // +  TRscObjLine
 PIMGDOT = ^TIMGDOT;
 TIMGDOT = packed record                // (129) 
  case byte of
   0:(Color : TColor;                   //   (COLORREF)
      Thick : integer;                  //  
      Dash  : integer;                  //  
      Blank : integer);                 //  
   1:(LINE : TIMGLINE;
      DotDash  : integer;               //  
      DotBlank : integer);              //  
 end;



//**********************************************************************
//     (  IMGDRAW...)
//**********************************************************************

 PIMGLINEDOT =^TIMGLINEDOT;
 TIMGLINEDOT = packed record             // (130)     (size = 24)
  Line : TImgLine;                      //  
  Dot  : TImgDot;                       //  
 end;

 PIMGDOUBLELINE =^TIMGDOUBLELINE;
 TIMGDOUBLELINE = packed record         // (131)     (size = 16)
  OneLine,                              //  
  TwoLine : TImgLine;                   //  
 end;

 PIMGDOTDLINE =^TIMGDOTDLINE;
 TIMGDOTDLINE   = packed record         // (132)      (size = 32)
   Dot   : TImgDot;                     //  
   dLine : TIMGDOUBLELINE;              //  
 end;

 PIMGDOUBLEDOT = ^TIMGDOUBLEDOT;
 TIMGDOUBLEDOT = packed record          // (133)    (size = 32)
  OneDot,                               //  
  TwoDot  : TImgDot;                    //  
 end;

 PIMGSHIFTLINEDOT = ^TIMGSHIFTLINEDOT;
 TIMGSHIFTLINEDOT = packed record       // (134) ,  ,     (size = 24)
  Line : TImgLine;                      //  
  Dot  : TImgDot;                       //  -
 end;


 PIMGSQUARE =^TIMGSQUARE;
 TIMGSQUARE = packed record             // (135)  '
  Color : TColor;                       //  
 end;

 PIMGSQUARECROSS = ^TIMGSQUARECROSS;
 TIMGSQUARECROSS = packed record        // (136)    (size = 16)
  Color,                                //  p (IMGC_TRANSPARENT - )
  Kind ,                                //  p (SC_HORIZONTAL, ...)
  Thick,                                // a pa
  Blank : cardinal                      // a pa
 end;

 // +  TRscObjPoint
 PIMGMARK = ^TIMGMARK;
 TIMGMARK = packed record               // (137)   '  (size = 16 + 128 = 144)
  Color : TColor;                       //  
  Size  : cardinal;                     //    ( )
  PosV  : cardinal;                     //    PosV,PosH < Size
  PosH  : cardinal;                     //  ( IMGSQUAREMARK -   >= Size
  Bits  : array [0..127] of byte;       //   32x32   
 end;

 PIMGSQUAREMARK = ^TIMGSQUAREMARK;
 TIMGSQUAREMARK = packed record         // (138)  +  (size = 8 + 144 = 152)
  Color    : TColor;                    //   (IMGC_TRANSPARENT - )
  Kind     : word;                      //    4x4 (16 ) (IMGK_REGULAR, ...)
  FullMark : byte;                      //   (0 -   ; 1 -   )
  Weight   : byte;                      //  ,   (0 - , 1 - )
  Mark     : TImgMark;                  //  
 end;

 //**********************************************************************
 PIMGCIRCLE = ^TIMGCIRCLE;
 TIMGCIRCLE = packed record              // (140)    (size = 12)
  Color   : TColor;                      //  
  Thick   : integer;                     //  
  Radius  : integer;                     //  
 end;

 PIMGTEXT = ^TIMGTEXT;
 TIMGTEXT = packed record               // (142)  (size = 32)
  Color       : cardinal;               //  
  BkgndColor  : cardinal;               //   (IMGC_TRANSPARENT - )
  ShadowColor : cardinal;               //   (IMGC_TRANSPARENT - )
  Height      : cardinal;               //  (      1800 )
  Weight      : cardinal;               //  ,   (FW_THIN, ...)
  Align       : word;                   //  (FA_LEFT|FA_BASELINE, ...)
  Service     : word;                   //  0
  Wide        : byte;                   //    (UNIW_NORMAL, ...)
  Horizontal  : byte;                   //    (0/1)
  Italic      : byte;                   //    (0/1)
  Underline   : byte;                   //      (0/1)
  StrikeOut   : byte;                   //     (0/1)
  FontType    : byte;                   //   (  : 0,1,2,3,4)
  CharSet     : byte;                   //   (RUSSIAN_CHARSET, ...)
  Flag        : byte;                   //    : 1 -    
end;

 // ************      **********************
 //   32x32   
 TPixelMask = packed record
  case byte of
   0: (Bits : array[0..127] of Byte);
   1: (Rows : array[0..31] of Cardinal); //   32  ()
 end;

 PIMGMARKCHAIN =^TIMGMARKCHAIN;
 TIMGMARKCHAIN = packed record      //   '   (size = 4 + 128 = 132)
  Color   : TColor ;                //  
  BitMask : TPixelMask;             //   32x32   
 end;

 PIMGMULTIMARKHEAD = ^TIMGMULTIMARKHEAD;
 TIMGMULTIMARKHEAD  = packed record         // (143)   (size = 20 + 132*Count)
  Length  : Longint;                    //     
  Count   : Longint;                    //    
  Size    : Longint;                    //    ( )
  PosV    : Longint;                    //    PosV,PosH  <  Size
  PosH    : Longint;                    //  ( IMGMULTISQUAREMARK -   >= Size)
                                        // : Count   IMGMARKCHAIN
 end;
 // +  TRscObjMark ( )
 PIMGMULTIMARK = ^TIMGMULTIMARK;
 TIMGMULTIMARK  = packed record
   Head   : TIMGMULTIMARKHEAD;
   Chains : array of PIMGMARKCHAIN;
 end;
 // ----------------------------------------------------------------------------

 PIMGMULTISQUAREMARK = ^TIMGMULTISQUAREMARK;
 TIMGMULTISQUAREMARK = packed record    // (144)  +   (size = 4 + 20+132*Count )
  Kind     : word;                      //    4x4 (16 ) (IMGK_REGULAR, ...)
  FullMark : byte;                      //   (0 -   , 1 -   )
  Weight   : byte;                      //  ,   (0 - , 1 - )
  Mark     :  TIMGMULTIMARK;            // (143)  
                                        // : Count   IMGMARKCHAIN
 end;

 PIMGLEFTLINEDOT = ^TIMGLEFTLINEDOT;
 TIMGLEFTLINEDOT  = packed record       // (145) ,  ,    (size = 24)
   Line : TIMGLINE;                     //  
   Dot  : TIMGDOT;                      //  -
 end;

 PIMGDECHEAD = ^TIMGDECHEAD;
 TIMGDECHEAD      = packed record       //   
  Length   : cardinal;                  //     
  Distance : integer;                   //    .
 end;


 PImgDecor = ^TImgDecor;
 TIMGDECOR =  record       //   
  Length : word;           //   >= 4  ( sizeof(IMGDECOR))
  Number : word;           //  
 end;

//     
 PIMGDECORATELINE  = ^TIMGDECORATELINE;
 TIMGDECORATELINE  = packed record       // (146)  
  Head        : TIMGDECHEAD;   // 
  Base        : TIMGDECOR;   //   
  BaseParm    : cardinal;   //    
  First       : TIMGDECOR;   //  
  FirstParm   : cardinal;   //   
  Last        : TIMGDECOR;   //  
  EndParm     : cardinal;   //   
  Left        : TIMGDECOR;   //  
  LeftParm    : cardinal;   //   
  Rigth       : TIMGDECOR;   //  
  RigthParm   : cardinal;   //   
  Middle1     : TIMGDECOR;   //   
  Mid1Parm    : cardinal;   //   
  Middle2     : TIMGDECOR;   //   
  Mid2Parm    : cardinal;   //   
 end;


 PIMGTHICKENLINE = ^TIMGTHICKENLINE;
 TIMGTHICKENLINE = packed record
  Color : TColor;   //  
  MinThick : integer;  //     
  MaxThick : integer;  //     
 end;


const
   IMGTEXT_SCALE = 1;
   IMGTEXT_SHOWCODE = 2;                       // 21/07/06
   //       // 28/07/00
   IMGD_SPLINE        = $0001; //     

type
  TIMGFONT = TIMGTEXT ;

   PImgDraw = ^TImgDraw;
   TImgDraw	= packed record
    Ident       : Cardinal;	    //   0x7FFF7FFFE
    Length	: Cardinal;	    //     
    Count	: Word;	            //  
    Flags 	: Word;		    //   0
    Image 	: TImgDecor;        //   
    pValue	: PChar;	    //    .
   end;


   PImgContext  = ^TImgContext;
   TImgContext = packed record
    Length      : Integer;      //     (64 )
    DC		: THandle;	//    (   UNIX = 0)
    View	: Integer;	//   VT_SCREEN, VT_PRINT (maptype.h)
    HView	: THandle;	//    ( )
    Size	: TSize;	//   
    Scale	: Single;	//       (        1)
    ScaleMethod	: Integer;	//   (0 - , 1 - ,  "")
    PixelX	: Double;	//        
    PixelY	: Double;	//        
    SinAngle	: Double;	// Sin          // 19/09/01
    CosAngle	: Double;	// Cos   
    Angle	: Double;	//    (  )
    Reserv1	: Integer;	//  = 0
    Reserv2	: Integer;      //  = 0
   end;



//typedef IMGDRAW  SCRDRAW ;
 PIMGDOTSHIFT = ^TIMGDOTSHIFT;
 TIMGDOTSHIFT = packed record           // (148)  
    Dot   : TImgDot;                    // 
    Shift : integer;                    //    
     // 0 -        > 0    , 
     //   = -        
 end;

TSCRDOTSHIFT = TIMGDOTSHIFT ;

PIMGVECTPOINT = ^TIMGVECTPOINT;
TIMGVECTPOINT = packed record    //  (149)    (size = 8)
   Hor : integer;                //    
   Ver : integer;                //     
                                 //   :
                                 //         
                                 // Circle, Round  (h,v)  (dh,dh)
                                 // Ellipse, Oval  (h,v)  (dh,dv)
                                 // Arc,      Pie  (h,v)  (dh,dv) (h1,v1)(h2,v2)
end;


PIMGVECTORTEXT  = ^TIMGVECTORTEXT ;
TIMGVECTORTEXT  = packed record  // (160)    (VT_TEXT)
                                 // (size = 68)
  Text  : TIMGTEXT ;             //  
  Code  : integer ;              //   ,   
                                 //   0   
  Title : array[0..31]of char;   //  
end;


PIMGTRUETYPE = ^TIMGTRUETYPE;
TIMGTRUETYPE = packed record   // (151)    TRUETYPE 
   Text         : TIMGTEXT;             //  
   FontName     : array[0..31] of char;             //   
   Number       : integer;               //    
   MinV         : integer;              //  
   MinH         : integer;               //    
   MaxV         : integer;               // (0,0)
   MaxH         : integer;              // (H,H/2) -  
   PosV         : integer;              //     
   PosH         : integer;              //   (0,0)
end;

PIMGTRUETEXT =^TIMGTRUETEXT;
TIMGTRUETEXT = packed record     // (152) 
   Text         : TIMGTEXT;      //   ( Type - )
   FontName     : array[0..31] of Char;  //   
end;

 PIMGHATCHSQUARE = ^TIMGHATCHSQUARE;
 TIMGHATCHSQUARE = packed record  // (153)  
  Length : integer;                       //     ,
                                //    
  Angle  : integer;                       //      (0 - 180)
                                //     
  Step   : integer;                        //     
  Number : integer;             //     (IMGLINE  IMGDOT)   //    
  Line   :  TIMGDOT;
end;


PIMGSQUAREGLASS = ^TIMGSQUAREGLASS;
TIMGSQUAREGLASS = packed record  // (154)  ' -    (size = 8)
  Bright    : integer;           //    (+/- 100)
  Contrast  : integer;           //    (+/- 100)
end;


const
   DO_BASE      = 1;           //   (  )
                                //   
   DO_FIRST     = 2;           //   
   DO_END       = 3;           //   
   DO_LEFT      = 4;           //    
   DO_RIGHT     = 5;           //    
   DO_MIDDLE1   = 6;           //   (1 - )
   DO_MIDDLE2   = 7;           //   (2 - )

type



PIMGSQUAREGLASSCOLOR = ^TIMGSQUAREGLASSCOLOR;
TIMGSQUAREGLASSCOLOR = packed record    // (164)  ' -  
                                       // (size = 12)
  Color : integer;                 //   (IMGC_TRANSPARENT - )
  Bright: integer;                 //    (+/- 100)
  Contrast: integer;               //    (+/- 100)
end;

PIMGGRAPHICMARK =^TIMGGRAPHICMARK;
TIMGGRAPHICMARK      = packed record    // (165)   -  
                                        // (size = 352)
  Length        : integer;              //     
  Ident         : integer;              //   = 0
  Name          : array[0..255] of char;//   
  FileType      : integer ;             // 1 - BMP, 2 - JPEG, 3 - Metafile
  Height        : integer;              //   ( , )
  Width         : integer;              //
  PosV          : integer;              //     
  PosH          : integer;              //   (  
  Shift         : integer;              //  
  Contour       : TIMGLINE;             //  
  ContourFlag   : byte;                 //   
  ShadeFlag     : byte;                 //   
  Reserv        : array[0..13]of Char ; // 
end;

PIMGHATCHSQUARESHIFT =^TIMGHATCHSQUARESHIFT;
TIMGHATCHSQUARESHIFT  = packed record    // (166)     
                                 // 04/04/08
  Length        : integer;       //     ,
                                 //    
  Angle         : integer;       //      (0,45,90,135,180,225,270,315)
                                 //     
  Step          : integer;       //     
  Number        : integer;       //     (IMGLINE, IMGDOT, IMGDASH)
  Shift         : integer;       //     
                                 // :   
end;

PIMGPOLYGONGLASS   = ^TIMGPOLYGONGLASS;
TIMGPOLYGONGLASS   = packed record    // (167)  ' -   C  
                                 // (size = 16) ( IMGSQUAREGLASSCOLOR)
  Color         : integer;       //   (IMGC_TRANSPARENT - , )
  Bright        : integer;       //    (+/- 100)
  Contrast      : integer;       //    (+/- 100)
  Transparency  : integer;       //   ( 0 -  ,  100 -  )
end;

PIMGLINEGLASS   = ^TIMGLINEGLASS;
TIMGLINEGLASS      = packed record    // (168)  ' -   C  
                                // (size = 20) ( IMGSQUAREGLASSCOLOR)
  Color         : Integer;      //   (IMGC_TRANSPARENT - , )
  Thick         : cardinal;     //  
  Bright        : Integer;      //    (+/- 100)
  Contrast      : Integer;      //    (+/- 100)
  Transparency  : Integer;      //   ( 0 -  ,  100 -  )
end;

PIMGDOTGLASS   = ^TIMGDOTGLASS;
TIMGDOTGLASS       = packed record    // (169)   -   C  
                                // (size = 28)
  Color         : Integer;      //   (IMGC_TRANSPARENT - , )
  Thick         : cardinal;     //  
  Dash          : cardinal;     //  p
  Blank         : cardinal;     //  p
  Bright        : Integer;      //    (+/- 100)
  Contrast      : Integer;      //    (+/- 100)
  Transparency  : Integer;      //   ( 0 -  ,  100 -  )
end;

PIMGMULTIMARKGLASS =^TIMGMULTIMARKGLASS;
TIMGMULTIMARKGLASS = packed record    // (170)   -  
                                 //      (size = 20 + 132*Count)
  Bright        : Integer;       //    (+/- 100)
  Contrast      : Integer;       //    (+/- 100)
  Transparency  : Integer;       //   ( 0 -  ,  100 -  )
  Mark          : TIMGMULTIMARK; //   
end;

PIMGLIBRARY =^TIMGLIBRARY;
TIMGLIBRARY     = packed record   // (250)  '( )
  Length        : Integer;              //     
  Code          : Integer;              //  DLL (IML)
  Index         : Integer;              //  DLL   
  FuncCode      : Integer;              //  
  Draw          : TIMGDRAW;              // 
end;

PIMGDOUBLE =^TIMGDOUBLE;
TIMGDOUBLE = packed record  // (253)    DOUBLE
  Value : double;
end;

PIMGLONG = ^TIMGLONG;
TIMGLONG = packed record  // (254)    LONG
  Value : integer;
end;

PIMGOBJECT = ^TIMGOBJECT;
TIMGOBJECT = packed record  // (255) / '
                            //     
  Color  : TColor;           //     
                             //  (IMGC_NOMARK -  )
  Incode : integer;          //   
                             //  (0 -   Excode  Local)
  Excode : integer;          //   
  Local  : integer;          //   (IMGL_LINE, ...)

    //    PaintMapObject(...) Incode 
  // .     ,  
  //     .
end;

PIMGVECTORGRADIENT = ^TIMGVECTORGRADIENT;
TIMGVECTORGRADIENT  = packed record   //  
  Color   : Cardinal;        //    (COLORREF)
  Left    : Cardinal;        //    
  Right   : Cardinal;        //    
  Bright  : Cardinal;        //    
end;

 //-----------------------------------------------------------------------------
 //
 //                    
 //
 //-----------------------------------------------------------------------------

 //     " "    
 // mapGetRscPrimitiveParameters       IML  
 //  TImgDraw
 //             
 // :
 // ------------
 //    
 //    () 1
 //    () 2
 //   .....
 //    () N
 // ------------
 //
 //   :
 // --------------
 // Head  : TIMGVECTORHEAD;
 // Desc1 : TIMGPOLYDESCHEAD;  //  1
 //    Dump1     :      ( )
 //    MetCount1 :  
 //    metric1   : array[1..MetCount] of TIMGVECTPOINT
 // Desc2 : TIMGPOLYDESCHEAD;  // 
 //    Dump2     :      ( )
 //    MetCount2 :  
 //    metric2   : array[1..MetCount] of TIMGVECTPOINT
 //  ...............
 // DescN : TIMGPOLYDESCHEAD;  // 
 //    DumpN     :      ( )
 //    MetCountN :  
 //    metricN   : array[1..MetCount] of TIMGVECTPOINT
 // ---------------
 //      ,        
 //   Dump (  )   
 // ,      (, , , ),  
 //  metric2         ,
 //         ,   
 //     
 // (-  +   + )
 //        ,   
 //  TIMGPOLYDESC  TIMGVECTOREX .
 //     ,       
 //   imgGetVectorRecord (imgproc.pas)

 //   
 PIMGVECTORHEAD = ^TIMGVECTORHEAD;
 TIMGVECTORHEAD = packed record   // (149,156)   '
  Length    : integer;            //     
  PosV      : integer;            //     
  PosH      : integer;            //    (  )
  Base      : integer;            //     
  VLine1    : integer;            //      (0)
  VLine2    : integer;            //       (VSize)
  VSize     : integer;            //     
  HLine1    : integer;            //     (0)
  HLine2    : integer;            //      (HSize)
  HSize     : integer;            //     
  Static    : byte;               // 1 -  
                                  // 0 -  
  Mirror    : byte;               //    
                                  //     
  NoPress   : byte;               //    
  Scale     : byte;               //    
  Centre    : byte;               //    
  Reserve   : array[0..2] of byte;             // 
  Border    : integer;            //        0
  Count     : integer;            //  , 
 end;

 //    
 PIMGPOLYDESCHEAD = ^TIMGPOLYDESCHEAD;
 TIMGPOLYDESCHEAD = packed record  //  6 
  NodeType      : byte;           //   (VT_SQUARE, ...)
                                  //    VT_OBJECT,VT_SUBJECT, VT_END)
  Image         : byte;           //  
                                  // (IMG_SQUARE, IMG_LINE, IMG_DOT,IMG_VECTORTEXT)  // 11/04/05
  Length        : word ;          //   (>= 4)
 end;

 TImgVectorData = packed record
  case byte of
   0: (Value     : Pointer);
   1: (ImgText   : PIMGVECTORTEXT);
   2: (ImgLine   : PIMGLINE);
   3: (ImgDot    : PIMGDOT);
   4: (ImgSquare : PIMGSQUARE);
 end;

 //     
 PIMGPOLYDESC= ^TIMGPOLYDESC;
 TIMGPOLYDESC = packed record
   HEAD     : TIMGPOLYDESCHEAD;   //  
   DATA     : TImgVectorData;     //    ( Image  TIMGPOLYDESCHEAD)
   MetCount : Integer;            //   
   MetData  : PIMGVECTPOINT;      //   
 end;
 TIMGPOLYARRAY = array of TIMGPOLYDESC;

  //         ,  
  //      .    
  //      ,   imgGetVectorRecord (imgproc.pas)
  // ,     (  )
  //          
  //   .

  //    
  PIMGVECTOREX = ^TIMGVECTOREX;
  TIMGVECTOREX = packed record
   HEAD : TIMGVECTORHEAD;   // 
   PRIM : TIMGPOLYARRAY;    //      
  end;

 //    TIMGTEXT
  TIMGDRAWTEXT = packed record
   HEAD     : TIMGVECTORHEAD;
   PRIMHEAD : TIMGPOLYDESCHEAD;
   DATA     : TIMGVECTORTEXT;
   MetCount : Integer;
   Point1   : TIMGVECTPOINT;
   Point2   : TIMGVECTPOINT;
  end;

 //-----------------------------------------------------------------------------
 //
 //                   
 //
 //-----------------------------------------------------------------------------
 //    
const	SEMBASESTRDOS	= 0;	// C  (ASCIIZ), 
	SEMBASESTRING	= 126;	// C  (ANSI), 
	SEMBASECHAR	= 1;	// 1    SIGNED CHAR
	SEMBASESHORT	= 2;	// 2 A  SIGNED SHORT
	SEMBASELONG	= 4;	// 4 A  SIGNED INT
	SEMBASEDOUBLE	= 8;	// 8    DOUBLE IEEE

 type
  // 
  PSemantic = ^TSemantic;
  TSemantic = packed record	//  '
   Ident   : Word;		// 0x7FFF
   Length  : Word;		//  
  end;

  PSemBlockHead = ^TSemBlockHead;
  TSemBlockHead = packed record
   Code	    : Word;     //  
   ValType  : Byte;
   Scale    : ShortInt;	//  
  end;
  TSemArray = array of PSemBlockHead;

  PSemBlock = ^TSemBlock;
  TSemBlock = packed record
   Code	    : Word;     //     (4-. 9-...)
   ValType  : Byte;     //   -  
   Scale    : ShortInt;	//  
   case Byte of
    126: (_String   : array[1..256] of Char);
    001: (_ShortInt : ShortInt);
    002: (_SmallInt : SmallInt);
    004: (_Integer  : Integer);
    008: (_Double   : Double);
  end;

  PPolyDataEx   = ^TPolyDataEx;
  TPolyDataEx	= record
    Points      : PPoints;	//     POINT   
    PolyCounts	: PInteger;	//    
    Count	: Integer;	//   (, )
    Text	: PPChar;	//       (      )
    AlignCode	: SmallInt;	//     
    Flags	: SmallInt;	//    -  0            // 05/06/07
    Semantic	: PSemantic;	//     (SEMANTIC *).       -  0
    Border	: TRect;	//        
    ShowScale	: Double;	//     
    MapRsc	: THandle;	//  ,   
    Height	: Single;	//     ( 3D-)  0  // 04/07/06
  end;



//------------------------------------------------------------------------------
PIMGSQUAREVECTOR = ^TIMGSQUAREVECTOR;
TIMGSQUAREVECTOR = packed record   // (155)  +                               //
  Length        : integer;         //  
  Kind          : word ;           //    4x4 (16 )
                                   //  (IMGK_REGULAR, ...)
  FullMark      : byte;            //  
                                   //  0 -   
                                   //  1 -   
  Reserv        : byte ;           //   0
  StepHor       : integer;         //     
  StepVer       : integer;         //     
  Angle         : integer;         //       
  Mark          : TIMGVECTORHEAD;  //  
end;

PPAINTEXAMPLE = ^TPAINTEXAMPLE;
TPAINTEXAMPLE  = packed record
  DC            : HDC;       //  
  Rect          : PRect;      //    

  Func          : integer;      //   (IMG_LINE, IMG_DOT, ...)
  Parm          : Pointer;      //    

  Data          : TPOLYDATAEX;  // 
                                //   ( Data != 0,  text )
                                //   ( Data == 0,   )

  Text          : PChar;        //     WINDOWS
                                //   ( Text == 0,   )

  Local         : integer;      //  (LOCAL_LINE, LOCAL_SQUARE, ...)
                                //   (  Data == 0)

  Factor        : double;       //   (Factor >= 0.0)
                                //  0.0 -  
  Colors        : integer;      //   
  Palette       : PColorRef;    //   
  VisualType    : integer;      //   (VT_SCREEN, VT_PRINT, ...)
                                //    0 - 
  FillIntensity : integer;  //   (0,100)
                            //    0 - 
                            //  100 -   
  Reserve       : array[0..15] of char;
end;

  PIMGDECORATE  = ^TIMGDECORATE;
  PIMGDASH  = ^TIMGDASH;
  PIMGTEMPLATE  = ^TIMGTEMPLATE;
  PIMGLINESHIFT  =^TIMGLINESHIFT;

  
TIMGSUBPRIMITIVE = packed record
case byte of
 IMG_EMPTY		: (Address: Pointer);	//   -  
 IMG_LINE		: (LINE: PIMGLINE);		// 
 IMG_DOT		: (DOT: PIMGDOT);			// 
 IMG_LINEDOT	: (LINEDOT: PIMGLINEDOT);		//*   
 IMG_DOUBLELINE	: (DOUBLELINE: PIMGDOUBLELINE);	//*   
 IMG_DOTDLINE	: (DOTDLINE: PIMGDOTDLINE);	//*    
 IMG_DOUBLEDOT	: (DOUBLEDOT: PIMGDOUBLEDOT);	//*  
 IMG_SHIFTLINEDOT	: (SHIFTLINEDOT: PIMGSHIFTLINEDOT);	//* ,  ,  
 IMG_SQUARE		: (SQUARE: PIMGSQUARE);		// 
 IMG_SQUARECROSS	: (SQUARECROSS: PIMGSQUARECROSS); //  
 IMG_MARK		: (MARK: PIMGMARK);			//   
 IMG_SQUAREMARK	: (SQUAREMARK: PIMGSQUAREMARK);	//   
 IMG_CIRCLE		: (CIRCLE: PIMGCIRCLE);		// 
 IMG_TEXT		: (TEXT: PIMGTEXT);			// 
 IMG_MULTIMARK	: (MULTIMARK: PIMGMULTIMARK);	//   
 IMG_MULTISQUAREMARK	: (MULTISQUAREMARK: PIMGMULTISQUAREMARK);	// ,   
 IMG_DRAW		: (DRAW: PIMGDRAW);	// +   
 IMG_DOTSHIFT	: (DOTSHIFT: PIMGDOTSHIFT);	//  
 IMG_VECTOREX	: (VECTOREX: PIMGVECTOREX);	//  
 IMG_TEMPLATE	: (TEMPLATE: PIMGTEMPLATE);	//  ( )
 IMG_TRUETYPE	: (TRUETYPE: PIMGTRUETYPE);	//  TrueType
 IMG_TRUETEXT	: (TRUETEXT: PIMGTRUETEXT);	// 
 IMG_HATCHSQUARE	: (HATCHSQUARE: PIMGHATCHSQUARE);	//  
 IMG_SQUAREGLASS	: (SQUAREGLASS: PIMGSQUAREGLASS);	// + -
 IMG_SQUAREVECTOR	: (SQUAREVECTOR: PIMGSQUAREVECTOR);	// ,   
 IMG_DECORATE	: (DECORATE: PIMGDECORATE);	//     
 IMG_DASH	 	: (DASH: PIMGDASH);		//  
 IMG_LINESHIFT	: (LINESHIFT: PIMGLINESHIFT);	//  
 IMG_VECTORTEXT	: (VECTORTEXT: PIMGVECTORTEXT);	//    
 IMG_THICKENLINE	: (THICKENLINE: PIMGTHICKENLINE);	//  
 IMG_SQUAREGLASSCOLOR	: (SQUAREGLASSCOLOR: PIMGSQUAREGLASSCOLOR);	// - 
 IMG_GRAPHICMARK	: (GRAPHICMARK: PIMGGRAPHICMARK);	//    (, Metafile )
 IMG_HATCHSQUARESHIFT	: (HATCHSQUARESHIFT: PIMGHATCHSQUARESHIFT);	//        
 IMG_POLYGONGLASS	: (POLYGONGLASS: PIMGPOLYGONGLASS);	// -   
 IMG_LINEGLASS	: (LINEGLASS: PIMGLINEGLASS);	// -   
 IMG_DOTGLASS	: (DOTGLASS: PIMGDOTGLASS);	//  -    // 15/02/09
 IMG_MULTIMARKGLASS	: (MULTIMARKGLASS: PIMGMULTIMARKGLASS);	// -      
 IMG_VECTORGRADIENT	: (VECTORGRADIENT: PIMGVECTORGRADIENT);	//  
 IMG_PERCENT	: (PERCENT: PIMGLONG);	//   IMG_LONG
 IMG_LIBRARY	: (ImlObject: PIMGLIBRARY);	//  IML
 IMG_SEMANTIC	: (SEMANTIC: PIMGLONG);	//   IMG_LONG
 IMG_COLOR		: (COLOR: PIMGLONG);	//   IMG_LONG
 IMG_DOUBLE		: (DOUBLE: PIMGDOUBLE);	//   DOUBLE
 IMG_LONG		: (LONG: PIMGLONG);	//   LONG
end;

 //-------------------------------------------------
 PIMGDECORHEAD = ^TIMGDECORHEAD;
 TIMGDECORHEAD = packed record   //   
  Length        : Cardinal;     //     
  FirstLen      : Cardinal;     //   
  LastLen       : Cardinal;     //   
  FirstLineLen  : integer;      //   
  LastLineLen   : integer;      //   
  FirstDecorLen : integer;      //    
  LastDecorLen  : integer;      //    
  Equidistant   : byte;         //     
  Reserv        : array[0..2] of byte;    //  -  0
 end;


 TElementRecord  = packed record
   Head  : TIMGDECOR;
   Data  : TIMGSUBPRIMITIVE;
 end;


 TIMGDECORATE  = packed record            // (157)  
  Head          : TIMGDECORHEAD;         // 
  PrimBase      : TElementRecord;
  PrimFirst     : TElementRecord;
  PrimLast      : TElementRecord;
  PrimFirstLine : TElementRecord;
  PrimLastLine  : TElementRecord;
  PrimFirstDecor: TElementRecord;
  PrimLastDecor : TElementRecord;
 end;



TIMGSECTIONHEAD  = packed record    //     (158)
  Length        : cardinal;     //   ( IMGSECTION)
  Number        : cardinal;     //  (IMG_EMPTY, IMG_LINE, IMG_VECTOREX,
                                //               IMG_TRUETYPE)
  Base          : cardinal;     //  ,  
end;

TIMGSECTION    = packed record
  Head          : TIMGSECTIONHEAD;
  BaseParm      : TIMGSUBPRIMITIVE; // 
end;

TIMGDASHHEAD  = packed record
  Length       : cardinal;       //     ,
  Count        : cardinal;       //    (, , )
  Last         : cardinal;       //    ( 0  Count-1),
                                 //   
  Border       : integer;        //   
  Reserve      : integer;           // 
end;

TIMGDASH  = packed record        // (158)   
  Head      : TIMGDASHHEAD;           // 
  Section   : array of TIMGSECTION;   //   
end;

// ------------  --------------------------------------
TTABLETEMPLATE = packed record     //    
  Length  : integer;               //  
  Order   : array [0..11] of integer;   //   
                                        // 0- 
                                        // -1   -2 
                                        // >0      ()
  Origin  : integer;                    //   
  Static  : integer;                    // 1 -  
                                        // 0 -  
end;


TIMGTEMPLATE = packed record  // (150)   
                              //      (size = 20 + ...)
  Length : integer;           //     
  Table  : TTABLETEMPLATE;    //    
  Count  : integer;           //  
  Text   : TElementRecord;    // 
  Line   : TElementRecord;    //  
  Mark   : TElementRecord;    //  
end;


TIMGLINESHIFT = packed record           // (159) C 
  Length        : integer;              //     ,
  Shift         : integer;              //    
                                        // = 0 -     
                                        // > 0 -    ,  
  Head          : TIMGDECOR;   // 
  Data          : TIMGSUBPRIMITIVE; //  
end;

