//****** SITAPI.H *************** Belenkov O.V.   ****** 04/06/09 ***
//******* SITAPI.H *************** Shabakov D.A.   ****** 09/12/03 ***
//******* SITAPI.H *************** Kruzhkov A.E.   ****** 04/12/07 ***
//******* SITAPI.H *************** Vitsko D.A.     ****** 23/11/05 ***
//*                                                                  *
//*              Copyright (c) PANORAMA Group 1991-2009              *
//*                      All Rights Reserved                         *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*           ' " "       *
//*             C; PASCAL; BASIC         *
//*                                                                  *
//*        ()          *
//*     ; ;          *
//*          ()       *
//*       .            *
//*          . *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*       Windows :                            *
//*                                                                  *
//*    //                                          *
//*    HINSTANCE libInst = ::LoadLibrary("gisacces.dll");            *
//*                                                                  *
//*    //                                                *
//*      : integer  (WINAPI * lpfn)(HMAP;const char*; long int);     *
//*    (FARPROC)lpfn = GetProcAddress(libInst; "OpenSiteForMap");    *
//*      : integer  hSite = (*lpfn)(hMap;"navigation.sit";0);        *
//*                                                                  *
//*    //                                          *
//*    ::FreeLibrary(libInst);                                       *
//*                                                                  *
//*******************************************************************/

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++       +++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  //*********************************************************
  //*                                                        *
  //*          /             *
  //*                                                        *
  //*********************************************************/


  //       
  // (     ( ))
  //     
  // hMap     -   
  // sitename -     
  // mode     -  / (GENERIC_READ; GENERIC_WRITE 
  //             0) GENERIC_READ -     
  //    

function mapOpenSiteForMap(Map : HMap; sitename: PChar; mode : integer) :HSite ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapOpenSiteForMapUn(Map : HMap; sitename : WideString; mode : integer) : HSite;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //       
  // hMap -   
  // hSite -    
  //  hSite == 0;    
  //    

function mapCloseSiteForMap(Map : HMap; Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // hMap -   
  // name -    
  //    

function mapCloseSiteForMapByName(Map : HMap; name: PChar) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    (  )
  // hMap -   
  // number -     
  //    

function mapDeleteSite(Map : HMap; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    (  )
  // name -     
  //    

function mapDeleteSiteByName(name  : PChar) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     
  // hMap  -   
  // hSite -    
  //    

function mapClearSite(Map : HMap; Site : HSite ): integer;     // 08/11/06
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // hMap  -   
  // hSite -    
  // newname -     
  //        ;   ;
  //   
  //     ;   
  //   
  //      mapDeleteSite()
  //   (   )  

function mapCopySite(Map : HMap; Site : HSite ; newname: PChar) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //            // 28/04/05
  // hmap -    
  // hSite -    
  // force -  ;   0;    
  //      
  //       
  //    ;    
  //  mapSaveSite

procedure mapSaveSite(Map : HMap; Site : HSite ; force: integer);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     
  // hMap -   
  //    

function mapGetSiteCount(Map : HMap): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //      
  //   
  // hMap  -   
  // hSite -    
  //    

function mapGetSiteNumber(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //     
  //   
  // hMap  -   
  // hSite -    
  //     

function mapGetSiteFileName(Map : HMap;Site : HSite ) : PChar;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     \LOG         // 28/04/08
  //   
  // hMap  -   
  // hSite -    
  //     

function mapGetLogPath(Map : HMap;Site : HSite ) : PChar;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //               // 05/08/07
  //   
  // hMap  -   
  // hSite -    
  // name  -    
  // size  -  
  //     

function mapGetSiteFileNameEx(Map : HMap;Site : HSite ; name : PChar; size:integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //               // 24/03/08
  //   UNICODE   
  //     

function mapGetSiteFileNameUn(Map : HMap;Site : HSite ;name : WideString; size:integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //     
  //     
  // hMap   -   
  // number -     
  //  number == 0;   
  // () ;  hMap (    HSITE)!
  //    

function mapGetSiteIdent(Map : HMap;number : integer) :HSite ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     
  //    
  // hMap -   
  // name -     
  //    

function mapGetSiteIdentByName(Map : HMap; name : PChar) : HSite;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //                  // 21/07/06
  // (    )
  // hMap -   
  //    

function mapGetActiveSite(Map : HMap): HSite;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //    
  // (    )
  // hMap -   
  // hSite -    
  //    

function mapSetActiveSite(Map : HMap;Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //     
  //   
  // hMap  -   
  // hSite -    
  // (  ()  hSite = hMap)
  //       
  //  (  1)
  //    

function mapGetSiteMode(Map : HMap;Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //  -          
  // hMap  -   
  // hSite -    
  //   -                                          // 12/02/08

function mapGetSiteCopyFlag(Map : HMap;Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //  -    
  // hMap  -   
  // hSite -    
  //   -  

function mapGetSiteEditFlag(Map : HMap;Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //     (0 -  )
  // hMap  -   
  // hSite -    
  // flag  -   
  //    

function mapSetSiteEditFlag(Map : HMap; Site : HSite; flag: integer) : integer;  // 02/02/09
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces
  //    
  // hMap  -   
  // hSite -    
  //    0 (  )  100 (  )

function mapGetSiteTransparent(Map : HMap;Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //     ( 0  100)
  // hMap  -   
  // hSite -    
  // transparent -     0 (  )
  //  100 (  )
  //    

function mapSetSiteTransparent(Map : HMap; Site : HSite ; transparent : integer): integer;  // 02/02/09
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //  -          // 12/11/07
  // hMap  -   
  // hSite -    
  //   -  

function mapGetSiteInquiryFlag(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        (0 -  )
  //     mapWhatObject
  // hMap  -   
  // hSite -    
  // flag  -   
  //    

function mapSetSiteInquiryFlag(Map : HMap; Site : HSite ;   flag: integer): integer; 
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //  -   
  // hMap  -   
  // hSite -    
  //   -  

function mapGetSiteViewFlag(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     (0 -  )
  // hMap  -   
  // hSite -     (    hMap)
  // flag  -   
  //    

function mapSetSiteViewFlag(Map : HMap; Site : HSite; flag: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       // 18/12/02
  // hMap  -   
  // number -     
  // order  - (0 -   ; 1 -   )
  //    0

function mapSetSiteViewOrder(Map : HMap; number, order : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        // 18/12/02
  // hMap  -   
  // number -     
  // D (0 -   ; 1 -   )
  //    0

function mapGetSiteViewOrder(Map : HMap; number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //     (sit)    // 04/12/07
  //   oldNumber -    
  //   newNumber -     
  //     0

function mapChangeOrderSiteShow(Map : HMap; oldNumber, newNumber: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //         
  // hMap  -   
  // number -     ( number == 0;  )
  //   bottomScale       
  //   topScale       
  //    0

function mapGetSiteRangeScaleVisible(Map : HMap;number : integer;
        var  bottomScale, topScale: integer): integer;  // 09/12/03
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //         
  // hMap  -   
  // number -     ( number == 0;  )
  // bottomScale   -      
  // topScale   -      
  //              bottomScale <= topScale;   0
  //    0

function mapSetSiteRangeScaleVisible(Map : HMap;number : integer;
             bottomScale, topScale: integer): integer;   // 09/12/03
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //        
  // hMap  -    
  // hSite -    
  //    

function mapGetMapPassportRecordLength(Map : HMap; Site : HSite) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // (    ;   ...)
  //      
  // (     )
  //      ;  
  //  mapGetMapPassportRecordLength()
  // hMap   -    
  // hSite  -    
  // buffer -       
  // size   -  
  //    

function mapGetMapPassportRecord(Map : HMap; Site : HSite ; 
      buffer  : PChar; size: integer  ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  //     mapGetMapPassportRecord()
  // hMap  -    
  // mapname -    (*.map  *.sit) !
  // rscname -    (*.rsc) !
  //  hMap = 0;  
  //   HMAP (. mapCreateMap()  mapapi.h)
  //    

function mapPutMapPassportRecord(Map : HMap; mapname, rscname,
     buffer: PChar; size: integer ) : HSite;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

{$ifndef HIDEFORMAT}
  // C     ()
  // (  - .   )
  //    2- 
  // hMap  -    
  // hSite -    
  //              
  // text  -     (  "")
  // kind  -  
  //     What...()  Seek...()  
  //     (text;kind  ..)
  //       
  //  HOBJ    FreeObject()
  //    

function mapCreateSiteObject(Map : HMap;Site : HSite;
            const kind : integer  = KM_IDDOUBLE2; // 27/04/01
            const text : integer  = 0): HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

{$endif}


  //     
  //   
  // hMap  -    
  // hObj  -    
  //    

function mapGetObjectSiteIdent(Map : HMap;Obj : HObj) : HSite;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      (  
  //      )
  //      
  //   ;     -
  //    ;  
  //    ( 32800).
  // (   mapRegisterObject())
  //       
  // hSite -    
  // hObj  -    
  // hMap  -    
  //        ;
  //         mapCommitObject
  //    

function mapSetObjectMap(Info : HObj; Site : HSite ): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapChangeObjectMap(Obj : HObj; Map : HMap; Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        !
  //   dfarme  0;  
  //   (mapGetPictureSize;...Width;...Height - 
  //   )
  //       
  //    
  //        Site;
  //      (mapCreateSite); 
  //   .     
  //  (    ).
  // hMap   -    
  // hSite  -    
  // dframe -      
  // place  -  
  //    

function mapSetSiteBorder(Map : HMap; Site : HSite;
   Frame : PMAPDFRAME; place: integer): integer; // 27/04/01
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //*********************************************************
  //*                                                        *
  //*          *
  //*     (HDC)    *
  //*        ::SetViewportOrgEx()*
  //*                                                        *
  //*********************************************************/

  //       
  //    (incode)
  // (0 -   ; !=0 -    )
  // rect  -    (Draw)
  //   (Picture).
  // hMap   -    
  // hSite  -    
  // hDC    -    
  // rect   -  
  //      
  //    

function mapPaintExampleSiteObject(Map : HMap;Site : HSite ;
      DC : HDC;var  Rect : TRect; incode: integer  ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //*********************************************************
  //*                                                        *
  //*      *
  //*                                                        *
  //*********************************************************/

  //      
  // (  : hSite = hMap)
  // hMap   -    
  // hSite  -    
  // select -   /
  //       
  // . mapCreateMapSelectContext(...)
  //    

function mapGetSiteViewSelect(Map : HMap;Site : HSite ; Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  // hMap   -    
  // hSite  -    
  // select -   /

procedure mapSetSiteViewSelect(Map : HMap;Site : HSite; Select : HSelect);
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    ( -16  +16)
  // hMap   -    
  // hSite  -    

function mapGetSiteBright(Map : HMap; Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    ( -16  +16)
  // hMap   -    
  // hSite  -    

function mapSetSiteBright(Map : HMap; Site : HSite ; bright: integer  ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    ( -16  +16)
  // hMap   -    
  // hSite  -    

function mapGetSiteContrast(Map : HMap; Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ( -16  +16)
  // hMap   -    
  // hSite  -    

function mapSetSiteContrast(Map : HMap; Site : HSite ; contrast: integer  ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  //  16  32
  // hMap   -    
  // hSite  -    
  //    

function mapGetSiteColorsCount(Map : HMap; Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     (  /)
  // hMap   -    
  // hSite  -    
  // colors -    COLORREF    
  // count  -   (  256)
  //    

function mapGetSitePalette(Map : HMap; Site : HSite ;
            var colors : TCOLORREF; count: integer) : integer; // 08/05/02
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     (  /)
  // hMap   -    
  // hSite  -    
  // colors -    COLORREF    
  // count  -   (  256)
  //    

function mapGetSiteColors(Map : HMap; Site : HSite ;
            var colors : TCOLORREF; count: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  //  colors  0;    
  // (   ;   )
  // hMap   -    
  // hSite  -    
  // colors -    COLORREF    
  // count  -   (  256)
  //    

function mapSetSiteColors(Map : HMap; Site : HSite ;
       var colors : TCOLORREF; count: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //*********************************************************
  //*                                                        *
  //*        '      *
  //*                                                        *
  //*           :     *
  //*        (Picture)  -  ;             *
  //*       ;  (Map) -  ;            *
  //*                                        *
  //*        (Plane)      -  ;               *
  //*                                        *
  //*        (Geo)        -  .             *
  //*                                                        *
  //*********************************************************/

  //        
  // (  hSite = hMap)                        // 02/02/06
  //   -     ()
  //    mapWhatActiveObject()
  // hMap   -    
  // hSite  -    
  // select -   /
  //                
  //          . mapCreateMapSelectContext(...)
  //    

function mapGetSiteActiveSelect(Map : HMap;Site : HSite ; Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // (  hSite = hMap)
  //   -     ()
  //    mapWhatActiveObject()
  // hMap   -    
  // hSite  -    
  // select -   ;
  //              
  //    

function mapSetSiteActiveSelect(Map : HMap;Site : HSite ; Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //       
  // (  hSite = hMap)
  // hMap   -    
  // hSite  -    
  // select -   /
  //                
  //          . mapCreateMapSelectContext(...)
  //    

function mapGetSiteSeekSelect(Map : HMap;Site : HSite ; Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // hMap   -    
  // hSite  -    
  // select -   ;
  //              
  //    

function mapSetSiteSeekSelect(Map : HMap;Site : HSite ;  Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // info     -   ;
  //   CreateObject()  CreateSiteObject();
  //      .
  // hMap   -    
  // hSite  -    
  // key   -    
  //    

function mapSeekSiteObject(Map : HMap;Site : HSite ;Info : HObj;
      key : integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // hMap   -    
  // hSite  -    
  // info     -   ;
  //   mapCreateObject()  mapCreateSiteObject();
  //      ;
  // select -   ;
  // flag -    (WO_FIRST=0; WO_NEXT=4...)
  //     -  

function mapSeekSiteSelectObject(Map : HMap;Site : HSite ; Info : HObj;
    Select : HSelect; flag: integer) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ;   
  //   mapSeekSiteSelectObject (   )
  // hMap   -    
  // hSite  -    
  // select -   
  //       

function mapSeekSiteSelectCount(Map : HMap;Site : HSite ;Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // (     )
  // hMap     -    
  // hSite    -    
  // info     -   ;
  //   mapCreateObject()  mapCreateSiteObject();
  //      ;
  // select -   ;
  // flag -    (WO_FIRST; WO_NEXT...)
  //     -  

function mapSeekSiteViewObject(Map : HMap;Site : HSite ;Info : HObj;
    Select : HSelect; flag : integer  ) : HObj;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //   ;   
  //   mapSeekSiteViewObject (   )
  // hMap   -    
  // hSite  -    
  // select -   
  //       

function mapSeekSiteViewCount(Map : HMap;Site : HSite;Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //*********************************************************
  //*                                                        *
  //*          *
  //*                                                        *
  //*********************************************************/

  //    
  // hMap   -    
  // hSite  -    
  //    

function mapGetSiteScale(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //   
  // hMap   -    
  // hSite  -    
  //     

function mapGetSiteName(Map : HMap;Site : HSite ) : PChar;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //      UNICODE
  // hMap   -    
  // hSite  -    
  // name   -     
  // size   -     
  //     

function mapGetSiteNameUn(Map : HMap;Site : HSite; name : WideString; size: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //    (. maptype.h)
  // hMap   -    
  // hSite  -    
  //    

function mapGetSiteType(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     
  //   (  PLANE)
  // X -  ; Y -  
  // .1 -   ;
  // .2 -  
  // hMap   -    
  // hSite  -    

function mapGetSiteX1(Map : HMap;Site : HSite): double;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapGetSiteY1(Map : HMap;Site : HSite): double;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapGetSiteX2(Map : HMap;Site : HSite): double;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapGetSiteY2(Map : HMap;Site : HSite) : double;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // hMap   -    
  // hSite  -    
  //    

function mapGetSiteObjectCount(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //     
  // hMap   -    
  // hSite  -    
  //  MAPREGISTEREX  LISTREGISTER   mapcreat.h
  //    

function mapGetSiteInfoEx(Map : HMap;Site : HSite; var mapreg: TMAPREGISTEREX;
  var listreg : TLISTREGISTER; sheetnumber: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //           // 23/08/04
  // (  hSite = hMap)
  // hMap   -    
  // hSite  -    
  // select -   
  //     ;   
  // (; ;  -  .  seekapi.h)
  // . mapCreateMapSelectContext(...)
  //    

function mapGetSiteUsedSelect(Map : HMap;Site : HSite; Select : HSelect) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


  //*********************************************************
  //*                                                        *
  //*                     *
  //*                                                        *
  //*********************************************************/

  //     
  // hMap   -    
  // hSite  -    
  //    

function mapGetSiteLayerCount(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  // hMap   -    
  // hSite  -    
  // number -   
  //    0
  //     

function mapGetSiteLayerName(Map : HMap;Site : HSite ; number : integer) :PChar;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //*********************************************************
  //*                                                        *
  //*      '  *
  //*                                                        *
  //*********************************************************/

  //      
  // hMap   -    
  // hSite  -    
  //    

function mapSiteRscObjectCount(Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  //   
  // hMap   -    
  // hSite  -    
  // layer  -  
  //    

function mapSiteRscObjectCountInLayer(Map : HMap;  Site : HSite ;layer : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //      
  //   
  // hMap   -    
  // hSite  -    
  // layer  -  
  // number -    
  //       

function mapSiteRscObjectNameInLayer(Map : HMap; Site : HSite ;
      layer, number : integer) : PChar;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  //      
  // hMap   -    
  // hSite  -    
  // layer  -  
  // number -    
  //    

function mapSiteRscObjectExcodeInLayer(Map : HMap; Site : HSite ;
       layer, number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    
  //      
  // hMap   -    
  // hSite  -    
  // layer  -  
  // number -    
  //     ( )

function mapSiteRscObjectLocalInLayer(Map : HMap; Site : HSite ;
      layer, number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    () 
  //      
  // hMap   -    
  // hSite  -    
  // layer  -  
  // number -    
  //    

function mapSiteRscObjectCodeInLayer(Map : HMap; Site : HSite ;
    layer, number : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //    () 
  //     
  // hMap   -    
  // hSite  -    
  // excode -   
  // local  -  
  //    

function mapSiteRscObjectCode(Map : HMap; Site : HSite ;
      excode, local: integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


 // ************************************************************
 //                                                            *
 //           '           *
 // (      )*
 //                                                            *
 // ************************************************************

 //  ()   
 // hMap   -    
 // hSite  -    
 // key    -   
 //    

function mapGetSiteObjectNumberByKey(Map : HMap; Site : HSite; key  : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //       
 //     mapUndeleteObjectByNumber 
 // mapUndeleteObject
 // hMap   -    
 // hSite  -    
 // ObjNumb -   
 //    

function mapDeleteSiteObjectNumber(Map : HMap;Site : HSite ; ObjNumb : integer ): integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

function mapDeleteSiteObjectByNumber(Map : HMap;Site : HSite ; ObjNumb : integer) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;


 //*********************************************************
 //*                                                        *
 //*      /               *
 //*                                                        *
 //*********************************************************/

  //   ( ) /
  //  
  //       : ;
  // ;   ; 
  // () ;   () 
  //         
  //   10  ;
  //         -  300 
  //      ; 
  //    
  // hMap   -    
  // hSite  -    
  //    

function mapCreateSiteSelectContext(Map : HMap;Site : HSite ) :HSelect ;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;
  //       
  //     
  // hMap   -    
  // hSite  -    
  //    

function mapSetSelectContextSite(Select : HSelect;Map : HMap;Site : HSite ) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //*********************************************************
  //*                                                        *
  //*                    *
  //*                                                        *
  //*********************************************************/

  //      
  // hmap -    
  // hsite -   
  // frmname -       (*.frm)
  // frame -       
  //    

function mapAddMarginalRepresentationSite(Map : HMap; Site : HSite ;
       frmname : PChar; var frame : TMapDFrame) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //      
 // hmap -    
 // hsite -   
 // frmname -       (*.frm)
 // frame -       
 // angle -   ( )
 // center -   (  )
 //    

function mapAddMarginalRepresentationSiteEx(Map : HMap; Site : HSite ;
             frmname : PChar; var frame : TMapDFrame; angle :double;
             var center : TDoublePoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // hmap -    
  // hsite -   
  // excode -  
  // x1;y1;x2;y2 -       
  // angle -   ( )
  // center -   (  )
  //    

function mapCreateLineSite(Map : HMap; Site : HSite ; excode: integer;
       x1,y1,x2,y2,angle: double; var center: TDoublePoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //        
  // hmap -    
  // hsite -   
  // framecode -   
  // fillcode -  
  // linecode -   
  // delta -        
  // frame -     
  // angle -   ( )
  // center -   (  )
  //    

function mapCreateFrameFillSite(Map : HMap; Site : HSite ;
       framecode, fillcode, linecode: integer;
       delta : double; var frame  : TMapDFrame;
       angle : double; var center : TDoublePoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

  //       
  // hmap -    
  // hsite -   
  // excode -   
  // text -  
  // x1;x2;y1;y2 -       
  // wide -   
  //      - UNIA_LEFT  -   
  //      - UNIA_CENTER -  
  //      - UNIA_RIGHT -   
  // vert -     (0  1)
  // angle -   ( )
  // center -   (  )
  //    

function mapCreateTitleSite(Map : HMap; Site : HSite ; excode: integer; 
   Text : PChar; x1,y1,x2,y2 : double; wide, vert: integer;
    angle : double; var center : TDoublePoint) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //   ''       
 //  sscanf
 // str - 
 // len -  
 // symbol -  ( == 0 -   ''  '^')
 //    0;  1

function mapPreSscanf(str : PChar; len : integer; symbol: Char) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

 //    ''     sscanf
 // str - 
 // len -  
 // symbol -  ( == 0 -   '^'  '')
 //    0;  1

function mapPostSscanf(str : PChar; len : integer; symbol: Char) : integer;
{$IFNDEF LINUXAPI} stdcall {$ELSE} cdecl {$ENDIF}
external sGisAcces;

